/// File: P5GloveSharp\P5Utils\P5Motion.h
/// 
/// ------------------------------------------------------------
/// Copyright (c) 2004
///   Antonio Cisternino (cisterni.unipi.it),
///   Diego Colombo      (colombod.unipi.it),
///   Giorgio Ennas      (   ennas.unipi.it),
///   Daniele Picciaia   (picciaia.unipi.it)
/// 
/// The use and distribution terms for this software are 
/// contained in the file named license.txt, which can be found 
/// in the root of this distribution.
/// By using this software in any fashion, you are agreeing to 
/// be bound by the terms of this license.
///
/// You must not remove this notice, or any other, from this
/// software.
/// ------------------------------------------------------------

#ifndef _P5MOTION_HPP_
#define _P5MOTION_HPP_

#define P5MOTION_XYZFILTERSIZE	5
#define P5MOTION_YPRFILTERSIZE	7

#define P5MOTION_YPRABSOLUTE	0
#define P5MOTION_YPRRELATIVE	1

#define	P5MOTION_NORMALAXIS		1
#define	P5MOTION_INVERTAXIS		-1

extern int nXPos, nYPos, nZPos;
extern float fXMickey, fYMickey, fZMickey;
extern float fAbsYawPos, fAbsPitchPos, fAbsRollPos;
extern float fRelYawPos, fRelPitchPos, fRelRollPos;


void P5Motion_Init (CP5DLL *device, int id);
void P5Motion_SetClipRegion(int xstart, int xend, int ystart, int yend, int zstart, int zend);
void P5Motion_InvertMouse (int xaxis, int yaxis, int zaxis);

void P5Motion_Process();


#endif