/// File: P5GloveSharp\include\P5Base.h
/// 
/// ------------------------------------------------------------
/// Copyright (c) 2004
///   Antonio Cisternino (cisterni.unipi.it),
///   Diego Colombo      (colombod.unipi.it),
///   Giorgio Ennas      (   ennas.unipi.it),
///   Daniele Picciaia   (picciaia.unipi.it)
/// 
/// The use and distribution terms for this software are 
/// contained in the file named license.txt, which can be found 
/// in the root of this distribution.
/// By using this software in any fashion, you are agreeing to 
/// be bound by the terms of this license.
///
/// You must not remove this notice, or any other, from this
/// software.
/// ------------------------------------------------------------

// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the P5BASE_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// P5BASE_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef P5BASE_EXPORTS
#define P5BASE_API __declspec(dllexport)
#else
#define P5BASE_API __declspec(dllimport)
#endif



class P5BASE_API CP5Base {
public:
	CP5Base(void);
	CP5Base(int index);
	~CP5Base(void);
	void InitDevice(int index);
	void Process(void);
	void SetClipRegion(int xStart, int xEnd, int yStart, int yEnd, int zStart, int zEnd);
	void MouseButtonAllocation(void);
	bool GetButton(int index);
	void SetMouseState(bool st);
	bool GetMouseState(void);
	bool IsInitialized(void);
	void Close(void);
	void InvertMouseX(bool invx);
	void InvertMouseY(bool invy);
	void InvertMouseZ(bool invz);
	void SetClickSensitivity(int finger, int value);
	void CalibrateSensors(void);
	void CalibratePosition(void);
	void SaveSensors(void);

	bool IsInvertdX(void);
	bool IsInvertdY(void);
	bool IsInvertdZ(void);

	int LeftBtn;
	int MiddleBtn;
	int RightBtn;


	float mX;
	float mY;
	float mZ;

	int pX;
	int pY;
	int pZ;

	float absYaw;
	float relYaw;

	float absPitch;
	float relPitch;

	float absRoll;
	float relRoll;

	float Thumb;
	float Index;
	float Middle;
	float Ring;
	float Pinky;


private:
	bool initialized;
	bool invX;
	bool invY;
	bool invZ;
	int DeviceID;
};
