@echo off

setlocal

set Target=Goblin
set TargetExt=exe
set LinkTarget=exe
set MainEntryPoint=
set IconFile=%Target%.ico
set DebugTargetDir=.
set ReleaseTargetDir=.

set UseWCS=1
set UseRotor=0
set IsDebug=1
set IsBugReport=0
set IsIncremental=0
set Ext=cs

set GAC=%WINDIR%\assembly\GAC
set NET=%WINDIR%\Microsoft.NET\Framework\v2.0.50727
set ROTOR_DIR=C:\PROJECTS\sharedsourcecli\clr\bin\rotor_x86\checked
set PATCHER_DIR=..\Patcher
set WICCA_BIN=..\Wicca\BIN

REM set Forms=%GAC%\System.Windows.Forms\1.0.5000.0__b77a5c561934e089\System.Windows.Forms.dll
REM set Drawing=%GAC%\System.Drawing\1.0.5000.0__b03f5f7f11d50a3a\System.Drawing.dll
REM set System=%GAC%\System\1.0.5000.0__b77a5c561934e089\System.dll

set DirectX=%GAC%\Microsoft.DirectX\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.dll
set Direct3D=%GAC%\Microsoft.DirectX.Direct3D\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.Direct3D.dll
if exist %GAC%\Microsoft.DirectX.Direct3DX\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.Direct3DX.dll set Direct3DX=%GAC%\Microsoft.DirectX.Direct3DX\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.Direct3DX.dll
if exist %GAC%\Microsoft.DirectX.Direct3DX\1.0.2903.0__31bf3856ad364e35\Microsoft.DirectX.Direct3DX.dll set Direct3DX=%GAC%\Microsoft.DirectX.Direct3DX\1.0.2903.0__31bf3856ad364e35\Microsoft.DirectX.Direct3DX.dll
if exist Microsoft.DirectX.Direct3DX.dll set Direct3DX=Microsoft.DirectX.Direct3DX.dll
set Forms=%NET%\System.Windows.Forms.dll
set Drawing=%NET%\System.Drawing.dll
set System=%NET%\System.dll
set Xml=%NET%\System.Xml.dll

if %UseRotor% EQU 0 set MSCORLIB=%ROTOR_DIR%\mscorlib.dll
if %UseRotor% EQU 0 set MSCORLIB=%NET%\mscorlib.dll

REM You must specify /win32icon so that the icon shows up in Windows Explorer.
REM You must specify /resource so that the DirectX Framework associates the icon
REM with the application window.

if "%LinkTarget%"=="" set LinkTarget=exe
if "%TargetExt%"=="" set TargetExt=exe

set Flags=/nologo /unsafe /target:%LinkTarget% /noconfig /nostdlib /D:TRACE /D:DEBUG

set References=/r:%WICCA_BIN%\Phx.Aop.dll /r:Goblin.Engine.dll /r:%DirectX% /r:%Direct3D% /r:%Direct3DX% /r:%System% /r:%Forms% /r:%Drawing% /r:%MSCORLIB% /r:%Xml%

set Sources=Launcher.%Ext%

if %IsDebug% EQU 1 set TargetExe=%DebugTargetDir%\%Target%.%TargetExt%
if %IsDebug% NEQ 1 set TargetExe=%ReleaseTargetDir%\%Target%.%TargetExt%

set Flags=%Flags% /out:%TargetExe%

if %IsDebug% EQU 1 set Flags=%Flags% /debug
if %IsIncremental% EQU 1 set Flags=%Flags% /incremental

if %IsBugReport% EQU 1 set Flags=%Flags% /bugreport:%TargetExe%.bugreport

if not "%MainEntryPoint%"=="" set Flags=%Flags% /main:%MainEntryPoint%
if not "%IconFile%"=="" set Flags=%Flags% /resource:%IconFile%

if %UseRotor% EQU 1 set COMPILER=%ROTOR_DIR%\csc.exe
if %UseRotor% NEQ 1 set COMPILER=%NET%\csc.exe

if .%Ext% == .wcs set COMPILER=%WICCA_BIN%\wcs.exe
if .%UseWcs% == .1 set COMPILER=%WICCA_BIN%\wcs.exe

if %UseRotor% NEQ 1 set Flags=%Flags% /nologo
if %UseRotor% NEQ 1 set Resources=%Resources% /win32icon:%Target%.ico

if exist "%TargetExe%" del "%TargetExe%"
if exist "%DebugTargetDir%\%Target%.pdb" del "%DebugTargetDir%\%Target%.pdb"
if exist "%TargetExe%.incr" del "%TargetExe%.incr"
if exist "%TargetExe%.bugreport" del "%TargetExe%.bugreport"

if not exist %DebugTargetDir%\nul mkdir %DebugTargetDir%
if not exist %ReleaseTargetDir%\nul mkdir %ReleaseTargetDir%

set BACKUP=%Cor_Enable_Profiling%
if "%BACKUP%"=="1" set Cor_Enable_Profiling=0

REM Create an empty file so that we don't get prompted when we specify /bugreport
echo "" > Empty.txt
echo %COMPILER% %Flags% %* %References% %Sources% < Empty.txt
%COMPILER% %Flags% %* %References% %Sources% < Empty.txt
set EXIT_CODE=%errorlevel%

if exist App.config copy App.config %TargetExe%.config > Empty.txt

del Empty.txt

if "%BACKUP%"=="1" call %PATCHER_DIR%\enable.bat

exit /b %EXIT_CODE%
