@echo off

setlocal

set Target=Goblin.Engine
set TargetExt=dll
set LinkTarget=library
set MainEntryPoint=
set IconFile=Engine.ico
set DebugTargetDir=..
set ReleaseTargetDir=..

set UseWCS=1
set UseRotor=0
set IsDebug=1
set IsBugReport=0
set IsIncremental=0
set Ext=cs

set GAC=%WINDIR%\assembly\GAC
set NET=%WINDIR%\Microsoft.NET\Framework\v2.0.50727
set ROTOR_DIR=C:\PROJECTS\sharedsourcecli\clr\bin\rotor_x86\checked
set PATCHER_DIR=..\Patcher
set WICCA_BIN=..\..\Wicca\BIN

REM set Forms=%GAC%\System.Windows.Forms\1.0.5000.0__b77a5c561934e089\System.Windows.Forms.dll
REM set Drawing=%GAC%\System.Drawing\1.0.5000.0__b03f5f7f11d50a3a\System.Drawing.dll
REM set System=%GAC%\System\1.0.5000.0__b77a5c561934e089\System.dll

set DirectX=%GAC%\Microsoft.DirectX\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.dll
set Direct3D=%GAC%\Microsoft.DirectX.Direct3D\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.Direct3D.dll
if exist %GAC%\Microsoft.DirectX.Direct3DX\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.Direct3DX.dll set Direct3DX=%GAC%\Microsoft.DirectX.Direct3DX\1.0.2902.0__31bf3856ad364e35\Microsoft.DirectX.Direct3DX.dll
if exist %GAC%\Microsoft.DirectX.Direct3DX\1.0.2903.0__31bf3856ad364e35\Microsoft.DirectX.Direct3DX.dll set Direct3DX=%GAC%\Microsoft.DirectX.Direct3DX\1.0.2903.0__31bf3856ad364e35\Microsoft.DirectX.Direct3DX.dll
REM if exist Microsoft.DirectX.Direct3DX.dll set Direct3DX=Microsoft.DirectX.Direct3DX.dll
set Forms=%NET%\System.Windows.Forms.dll
set Drawing=%NET%\System.Drawing.dll
set System=%NET%\System.dll
set Xml=%NET%\System.Xml.dll
set Utilities=..\..\Common\Columbia.Utilities.dll

if %UseRotor% EQU 0 set MSCORLIB=%ROTOR_DIR%\mscorlib.dll
if %UseRotor% EQU 0 set MSCORLIB=%NET%\mscorlib.dll

REM You must specify /win32icon so that the icon shows up in Windows Explorer.
REM You must specify /resource so that the DirectX Framework associates the icon
REM with the application window.

if "%LinkTarget%"=="" set LinkTarget=exe
if "%TargetExt%"=="" set TargetExt=exe

set Flags=/nologo /unsafe /target:%LinkTarget% /noconfig /nostdlib /D:TRACE /D:DEBUG

set References=/r:%WICCA_BIN%\Phx.Aop.dll /r:%DirectX% /r:%Direct3D% /r:%Direct3DX% /r:%System% /r:%Forms% /r:%Drawing% /r:%MSCORLIB% /r:%Xml% /r:%Utilities%

REM set Sources=/recurse:D3DX\*.%EXT% /recurse:Devices\*.%EXT% /recurse:Physics\*.%EXT% /recurse:Utilities\*.%EXT% /recurse:Scene\*.%EXT% Engine.%EXT%

set Sources=D3DX\AssemblyInfo.%EXT% D3DX\dxmut.%EXT% D3DX\dxmutdata.%EXT% D3DX\dxmutenum.%EXT% D3DX\dxmutexception.%EXT% D3DX\dxmutgui.%EXT% D3DX\dxmutmesh.%EXT% D3DX\dxmutmisc.%EXT% D3DX\dxmutSettingsDlg.%EXT% Devices\InterSense\InterSense.%EXT% Devices\InterSense\InterSenseSocket.%EXT% Devices\InterSense\InterSenseStation.%EXT% Devices\InterSense\ISDllBridge.%EXT% Devices\InputDevice.%EXT% Devices\InputDeviceDriver.%EXT% Devices\InputDeviceMapper.%EXT% Devices\InputDevice_6DOF.%EXT% Physics\Collision.%EXT% Utilities\MyUtility.%EXT% Scene\Nodes\CameraNode.%EXT% Scene\Nodes\DamagableNode.%EXT% Scene\Nodes\DamagingNode.%EXT% Scene\Nodes\Node.%EXT% Scene\Transformers\AccelerationTransformer.%EXT% Scene\Transformers\ChaseAITransformer.%EXT% Scene\Transformers\CollisionDamageControl.%EXT% Scene\Transformers\CollisionSticker.%EXT% Scene\Transformers\CombinerTransformer.%EXT% Scene\Transformers\DXCameraTransformer.%EXT% Scene\Transformers\ICollisionListener.%EXT% Scene\Transformers\IgnoreCollision.%EXT% Scene\Transformers\InverterTransformer.%EXT% Scene\Transformers\TrackerTransformer.%EXT% Scene\Transformers\Transformer.%EXT% Scene\Transformers\VelocityTransformer.%EXT% Scene\Transformers\Xfrm.%EXT% Scene\Bounds.%EXT% Scene\MyMeshContainer.%EXT% Scene\SceneGraph.%EXT% Engine.%EXT%

if %IsDebug% EQU 1 set TargetExe=%DebugTargetDir%\%Target%.%TargetExt%
if %IsDebug% NEQ 1 set TargetExe=%ReleaseTargetDir%\%Target%.%TargetExt%

set Flags=%Flags% /out:%TargetExe%

if %IsDebug% EQU 1 set Flags=%Flags% /debug
if %IsIncremental% EQU 1 set Flags=%Flags% /incremental

if %IsBugReport% EQU 1 set Flags=%Flags% /bugreport:%TargetExe%.bugreport

if not "%MainEntryPoint%"=="" set Flags=%Flags% /main:%MainEntryPoint%
if not "%IconFile%"=="" set Flags=%Flags% /resource:%IconFile%

if %UseRotor% EQU 1 set COMPILER=%ROTOR_DIR%\csc.exe
if %UseRotor% NEQ 1 set COMPILER=%NET%\csc.exe

if .%Ext% == .wcs set COMPILER=%WICCA_BIN%\wcs.exe
if .%UseWcs% == .1 set COMPILER=%WICCA_BIN%\wcs.exe

if %UseRotor% NEQ 1 set Flags=%Flags% /nologo
if %UseRotor% NEQ 1 set Resources=%Resources% /win32icon:%Target%.ico

if exist "%TargetExe%" del "%TargetExe%"
if exist "%DebugTargetDir%\%Target%.pdb" del "%DebugTargetDir%\%Target%.pdb"
if exist "%TargetExe%.incr" del "%TargetExe%.incr"
if exist "%TargetExe%.bugreport" del "%TargetExe%.bugreport"

if not exist %DebugTargetDir%\nul mkdir %DebugTargetDir%
if not exist %ReleaseTargetDir%\nul mkdir %ReleaseTargetDir%

set BACKUP=%Cor_Enable_Profiling%
if "%BACKUP%"=="1" set Cor_Enable_Profiling=0

REM Create an empty file so that we don't get prompted when we specify /bugreport
echo "" > Empty.txt
echo %COMPILER% %Flags% %* %References% %Sources% < Empty.txt
%COMPILER% %Flags% %* %References% %Sources% < Empty.txt
set EXIT_CODE=%errorlevel%

del Empty.txt

if "%BACKUP%"=="1" call %PATCHER_DIR%\enable.bat

exit /b %EXIT_CODE%
