///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2005 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Engine/Devices/InputDevice.cs 5     1/12/07 2:23p Eaddy $
//
//    File name:	InputDevice.cs
//   Created by:	John Waugh
//   Created on:	04/08/2005
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Engine/Devices/InputDevice.cs $
 * 
 * 5     1/12/07 2:23p Eaddy
 * o After annotating all statements with their corresponding requirements
 * 
 * 4     9/29/06 6:18p Eaddy
 * o Annotated program elements with the concern they realize
 * 
 * 3     5/28/05 1:20p Eaddy
 * Changed copyright
 * 
 * 2     5/07/05 12:44p Eaddy
 * o Added comment header
 */

using Phx.Aop.Attributes;

using System;
using System.Xml.Serialization;

namespace Goblin.Engine.Devices
{
	/// <summary>
	/// This is the class that a user of Goblin will deal with.
	/// Under the hood, this class wraps InputDriver, which in turn is
	/// subclassed for specific devices, such as InterSense 900, etc.
	/// </summary>
	[Feature("Input")]
	[Requirement("Device.Device abstraction (#100)")]
	[Requirement("Device.Dynamic device discovery (#105)")]
	[Requirement("Configuration.Device configuration files (#135)")]
	public class InputDevice
	{
		public InputDevice()
		{
			//[Feature("Persistence")]
			identifier = "<no uid specified>";
		}

		[XmlElement("input_uid")]
		[Feature("Persistence")]
		[Requirement("Configuration.Device configuration files (#135)")]
		public string identifier;
	}
}
