///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2005 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Engine/Engine.cs 86    2/02/07 5:18a Eaddy $
//
//    File name:	Engine.cs
//   Created by:	Marc Eaddy
//   Created on:	02/02/2005
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Engine/Engine.cs $
 * 
 * 86    2/02/07 5:18a Eaddy
 * o Final assignment used for ASOC submission
 * 
 * 85    1/22/07 12:12a Eaddy
 * o Cleaned up some redundant and missing annotations
 * 
 * 84    1/19/07 5:31p Eaddy
 * o Added Requirement annotations
 * 
 * 83    1/12/07 2:23p Eaddy
 * o After annotating all statements with their corresponding requirements
 * 
 * 82    10/10/06 3:14p Eaddy
 * o Removed redundant concern annotations
 * o We now have 100% concern annotation coverage
 * 
 * 81    9/29/06 6:17p Eaddy
 * o Annotated program elements with the concern they realize
 * 
 * 80    5/12/06 2:00a Eaddy
 * o Added hard reference to LogFileAspect temporarily
 * for the demo.  Need to remove this later.
 * 
 * 79    5/02/06 11:03a Eaddy
 * o Moved MyTrace into separate library
 * 
 * 78    12/14/05 2:53p Eaddy
 * o Commented some messages
 * 
 * 77    11/11/05 5:41p Eaddy
 * o Changed fov to use Sony camera settings
 * 
 * 76    6/02/05 9:41p Eaddy
 * o Moved some camera parameters into Botica
 * 
 * 75    5/31/05 5:46p Eaddy
 * o Added ability to filter which nodes are rendered using a string
 * 
 * 74    5/31/05 2:58p Eaddy
 * o Can now press B to toggle displaying bounding volumes
 * 
 * 73    5/30/05 7:48p Eaddy
 * o Added comment
 * 
 * 72    5/30/05 7:46p Eaddy
 * o Can now take a screenshot using 'P'
 * 
 * 71    5/28/05 1:20p Eaddy
 * Changed copyright
 * 
 * 70    5/17/05 10:47p Eaddy
 * o Added SceneGraphInited which was needed so that LigerHunter could
 * obtain
 * the bounding box for the lab
 * 
 * 69    5/13/05 6:53p Eaddy
 * o Got rid of L, use P instead
 * 
 * 68    5/13/05 6:36p Eaddy
 * o Can't turn on culling since 3DS culls clockwise by meshes created by
 * D3DX cull counterclockwise
 * 
 * 67    5/13/05 6:29p Eaddy
 * o Turned on culling to hopefully improve performance
 * 
 * 66    5/10/05 9:25a Eaddy
 * o Now automatically loads plugins that are found in the current or
 * Engine directories
 * 
 * 65    5/07/05 12:55p Eaddy
 * o Now disposes of stuff properly
 * o Moved code out of Main() and into CTOR, Run(), and Shutdown()
 * 
 * 64    5/06/05 6:54p Eaddy
 * o Now starts of in full screen on the secondary monitor
 * 
 * 63    4/25/05 6:05p Eaddy
 * o Can now toggle whether real objects should be drawn black (for
 * augmented reality)
 * 
 * 62    4/25/05 4:01p Eaddy
 * o Comments
 * o Now calls CombineTransformations so the applications don't have to
 * 
 * 61    4/25/05 1:45p Eaddy
 * o Fixed crash that occured when switching screens (bolt mesh needs to
 * be recreated)
 * o Fixed bug where key events were being stolen by LigerHunter
 * o Can now toggle wireframe
 * 
 * 60    4/22/05 5:13p Eaddy
 * o Removed unused class
 * 
 * 59    4/22/05 3:19p Eaddy
 * o Removed spurious error message
 * 
 * 58    4/15/05 9:29p Eaddy
 * o Made sampleFramework public so that LigerHunter can get key presses
 * 
 * 57    4/15/05 2:10p Edp2002
 * removed hardcoded path
 * 
 * 56    4/08/05 5:30p Eaddy
 * o Now display system error message ("access is denied")
 * 
 * 55    4/08/05 4:48p Jrw2005
 * 
 * 54    4/08/05 4:36p Jrw2005
 * 
 * 53    4/08/05 4:30p Jrw2005
 * 
 * 52    4/08/05 1:45p Jrw2005
 * 
 * 51    4/06/05 7:02p Eaddy
 * o Minor method sig changes
 * 
 * 50    4/05/05 6:48p Eaddy
 * o Searches for the plugin in different directories
 * 
 * 49    4/05/05 5:37p Eaddy
 * o Trivial
 * 
 * 48    4/05/05 5:22p Eaddy
 * o No longer clips the cursor when in fullscreen. Needed so we can edit
 * source files in the other screen.
 * 
 * 47    4/05/05 5:10p Eaddy
 * o Engine is now a DLL so that other projects can reference it (e.g.
 * LigerHunter)
 * o Added "Goblin" project which is an EXE that starts the Engine. Run
 * this, not Engine.
 * o Extracted all app config related code into separate app-specific
 * project called LigerHunter
 * 
 * 46    4/01/05 8:53p Edp2002
 * still unfinished collision detection
 * 
 * 45    4/01/05 7:32p Edp2002
 * unfinished collision detection changes
 * 
 * 44    4/01/05 5:27p Eaddy
 * o Now sets the projection matrix properly
 * o Fixed field of view
 * 
 * 43    4/01/05 3:37p Eaddy
 * o Fixed crash when moving Goblin window to another screen
 * 
 * 41    3/23/05 10:56p Eaddy
 * o More BSP work
 * 
 * 40    3/22/05 6:21p Eaddy
 * o Made the liger more visible initially
 * 
 * 39    2/25/05 7:33p Edp2002
 * Liger now uses sphere collision
 * 
 * 38    2/25/05 4:02p Jrw2005
 * 
 * 37    2/22/05 11:36p Eaddy
 * o Now NodeController uses the delegate to control the node
 * 
 * 36    2/22/05 11:33p Eaddy
 * o Added Node.SetController() method
 * 
 * 35    2/22/05 11:32p Eaddy
 * o Now uses lightweight C# delegates instead of Java-style interfaces
 * for the node controllers
 * o Consolidated tracked camera initialization
 * 
 * 34    2/22/05 4:09p Eaddy
 * o Now uses the HMD tracker for the camera correctly
 * 
 * 33    2/22/05 2:53p Eaddy
 * o Removed my last changes
 * 
 * 32    2/18/05 9:59p Eaddy
 * o Created a generic 6DOF controller class that supports 6DOF data from
 * a DX camera or an IS900 tracker
 * 
 * 31    2/18/05 8:56p Eaddy
 * o Changed method names to uppercase
 * o Now the camera is really part of the scenegraph and gets rendered
 * just like any other node
 * 
 * 30    2/18/05 8:34p Eaddy
 * o Changed MyFrame to Node for clarity
 * 
 * 29    2/18/05 7:55p Eaddy
 * o Made method names consistent by starting them with uppercase
 * 
 * 28    2/18/05 7:47p Eaddy
 * o Removed unused variable
 * 
 * 27    2/18/05 7:11p Edp2002
 * addCamera renamed addEmptyNode
 * 
 * 26    2/18/05 7:07p Edp2002
 * camera added as node in scene graph
 * 
 * 25    2/18/05 6:48p Eaddy
 * o Now locates Tiger from Media directory
 * 
 * 24    2/18/05 6:44p Edp2002
 * liger scale and translate
 * 
 * 23    2/18/05 2:46p Edp2002
 * liger ... but better
 * 
 * 22    2/18/05 2:37p Eaddy
 * o Moved code into MyFrame
 * 
 * 21    2/17/05 3:37p Eaddy
 * o Now tracked camera works!!
 * 
 * 20    2/11/05 9:02p Eaddy
 * o Turned off culling for now
 * 
 * 19    2/11/05 8:42p Eaddy
 * o Fixed runtime exception
 * 
 * 18    2/11/05 8:38p Eaddy
 * o Removed test code
 * 
 * 17    2/11/05 8:37p Eaddy
 * 
 * 16    2/11/05 1:31p Edp2002
 * more liger
 * 
 * 15    2/11/05 12:11p Edp2002
 * liger
 * 
 * 14    2/10/05 9:39p Eaddy
 * o Testing
 * 
 * 13    2/04/05 7:37p Eaddy
 * o Modified camera view parameters
 * 
 * 12    2/04/05 7:33p Eaddy
 * o Added button and F4 to allow toggling of using a tracked camera
 * o Now displays current view position
 * 
 * 11    2/04/05 5:51p Eaddy
 * o Still trying to get a tracked camera to work
 * 
 * 10    2/04/05 4:47p Benko
 * Handles View Frustum changes for full screen HMD mode! in
 * OnFullscreenClicked
 * 
 * 9     2/04/05 3:52p Edp2002
 * added using Goblin.Engine.Physics
 * 
 * 8     2/04/05 3:11p Eaddy
 * o First stab at integrating a tracked camera
 * 
 * 7     2/04/05 2:41p Eaddy
 * o Started adding InterSense tracking code
 * 
 * 6     2/02/05 8:25p Eaddy
 * o Now shows framerate
 * 
 * 5     2/02/05 8:13p Eaddy
 * o Fixed bug where program would crash if you resized (this is actually
 * previous checkin comment)
 * o Commented out some DX flags that don't appear necessary
 * 
 * 4     2/02/05 8:01p Eaddy
 * o Got lighting to work
 * 
 * 3     2/02/05 5:06p Eaddy
 * o Removed effects code
 * 
 * 2     2/02/05 4:57p Eaddy
 * o Added VSS comment header
 */
 
//#define DEBUG_VS   // Uncomment this line to debug vertex shaders 
//#define DEBUG_PS   // Uncomment this line to debug pixel shaders 

using Phx.Aop.Attributes;

using System;
using System.IO;
using System.Reflection;
using System.Collections;
using System.Diagnostics;
using System.Configuration;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using Columbia.Utilities;

using Goblin.Engine.Scene;
using Goblin.Engine.Physics;
using Goblin.Engine.Devices;
using Goblin.Engine.Utilities;

namespace Goblin.Engine
{
    [Feature("Plugins")]
	[Requirement("App Development.Event-based programming model (#1105)")]
	[Requirement("App Development.Dynamic application loading (#1145)")]
	public interface IApp : IDisposable
	{
		[Requirement("App Development.Object model (#1110)")]
		void Init(Engine engine);
		
		[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		void SceneGraphInit(Device device);

		[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		void SceneGraphInited(Device device);
		
		[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		void FrameMove(Device device, float fps, float elapsedTime);
	}

    /// <summary>Engine Sample Class</summary>
    public class Engine : IFrameworkCallback, IDeviceCreation, IDisposable
    {
		// Variables
		[Feature("GUI")]
		[Requirement("App Development.Object model (#1110)")]
		[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
		public Framework sampleFramework = null;	// D3DX Framework
		[Feature("Stats")]
		[Feature("Help")]
		[Requirement("Operational.Frames per second display (#1315)")]
		[Requirement("UI.Help (#960)")]
		private Font statsFont = null;				// Font for drawing text
		[Feature("Help")]
		[Requirement("Operational.Frames per second display (#1315)")]
		[Requirement("UI.Help (#960)")]
		private Sprite textSprite = null;			// Sprite for batching text calls
		[Feature("Help")]
		[Requirement("UI.Help (#960)")]
		private bool isHelpShowing = true;			// If true, renders the UI help text
		[Feature("ScreenCapture")]
		[Requirement("Rendering.Video/image capture (#745)")]
		private bool doPrintScreen = false;
		[Feature("GUI")]
		[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
		[Requirement("Device.Single monitor displays (#165)")]
		[Requirement("Device.Multi-monitor displays (#190)")]
		[Requirement("Device.Position and orientation trackers (#150)")]
		[Requirement("Device.Head mounted displays (#195)")]
		[Requirement("3D UI.Optical see-through HMD support (#910)")]
		[Requirement("3D UI.Monoscopic display support (#915)")]
		private Dialog hud = null;					// dialog for standard controls
		[Feature("SampleUI")]
		[Requirement("Nonfunctional.Unused (#1400)")]
		private Dialog sampleUi = null;				// dialog for sample specific controls

		[Feature("GUI")]
		[Requirement("3D UI.Optical see-through HMD support (#910)")]
		[Requirement("3D UI.Real-world object occlusion (#935)")]
		[Requirement("Operational.Performance tuning (#1325)")]
		[Requirement("Debugging.Application visualization (#620)")]
		private FillMode fillMode = FillMode.Solid;

		[Feature("Plugins")]
		[Requirement("App Development.Dynamic application loading (#1145)")]
		private ArrayList appPlugins = null;

		[Feature("GUI")]
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("App Development.Object model (#1110)")]
		[Requirement("Rendering.Dynamic scene geometry (#740)")]
		public SceneGraph sceneGraph = null;

		[Feature("Input")]
		[Requirement("Device.Device abstraction (#100)")]
		[Requirement("Device.Dynamic device discovery (#105)")]
		public InputDeviceMapper inputMapper = null;

		// HUD UI Control constants
		[Feature("GUI")]
		[Requirement("3D UI.Optical see-through HMD support (#910)")]
		[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
		private const int ToggleFullscreen	= 1;
		[Feature("GUI")]
		[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
		private const int ToggleReference	= 3;
		[Feature("GUI")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
		private const int ChangeDevice		= 4;
		[Feature("GUI.Camera")]
		[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
		[Requirement("Device.Position and orientation trackers (#150)")]
		private const int UseTrackedCamera	= 5;

		// Camera
		[Feature("GUI.Camera")]
		[Requirement("Device.Position and orientation trackers (#150)")]
		[Requirement("Device.Single monitor displays (#165)")]
		[Requirement("Device.Multi-monitor displays (#190)")]
		[Requirement("Device.Head mounted displays (#195)")]
		[Requirement("3D UI.Optical see-through HMD support (#910)")]
		[Requirement("3D UI.Monoscopic display support (#915)")]
		public FirstPersonCamera dxFirstPersonCamera = new FirstPersonCamera(); // D3DX camera
		[Feature("GUI.Camera")]
		[Requirement("Device.Single monitor displays (#165)")]
		[Requirement("Device.Multi-monitor displays (#190)")]
		[Requirement("Device.Head mounted displays (#195)")]
		[Requirement("3D UI.Optical see-through HMD support (#910)")]
		[Requirement("3D UI.Monoscopic display support (#915)")]
		public CameraNode nodeCamera = null; // SceneGraph node for camera
		[Feature("GUI.Camera")]
		[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
		[Requirement("Device.Position and orientation trackers (#150)")]
		public Button trackedCameraBtn = null; // Toggles useTrackedCamera
		[Feature("GUI.Camera")]
		[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
		[Requirement("Device.Position and orientation trackers (#150)")]
		public bool useTrackedCamera = false; // Whether to use D3DX camera controller or isense

		// Events
		[Feature("Input")]
		[Requirement("Device.Digital devices (#155)")]
		[Requirement("Device.Device events (#205)")]
		public event KeyboardCallback keyEvent;
		[Feature("Input")]
		[Requirement("Device.Digital devices (#155)")]
		[Requirement("Device.Device events (#205)")]
		[Requirement("App Development.Event-based programming model (#1105)")]
		public event MouseCallback mouseEvent;
		[Feature("GUI")]
		[Requirement("Nonfunctional.Unused (#1400)")]
		public event WndProcCallback wndProcEvent;
		//public event TimerCallback timerEvent;

		//-------------------------------------------------
		// CTOR/DTOR
		//-------------------------------------------------

        /// <summary>DEFAULT CTOR</summary>
        public Engine() 
        { 
			// Create sample framework
			//[Feature("GUI")]
			//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			sampleFramework = new Framework();

			// Create dialogs
			//[Feature("GUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
			hud = new Dialog(sampleFramework);
            //[Feature("SampleUI")]
            //[Requirement("Nonfunctional.Unused (#1400)")]
            sampleUi = new Dialog(sampleFramework);

			// Set the callback functions. These functions allow the sample framework to notify
			// the application about device changes, user input, and windows messages
			//[Feature("GUI")]
			//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			sampleFramework.Disposing += new EventHandler(this.OnDestroyDevice);
			//[Feature("GUI")]
			//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			sampleFramework.DeviceLost += new EventHandler(this.OnLostDevice);
			//[Feature("GUI")]
			//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			sampleFramework.DeviceCreated += new DeviceEventHandler(this.OnCreateDevice);
			//[Feature("GUI")]
			//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			sampleFramework.DeviceReset += new DeviceEventHandler(this.OnResetDevice);

			//[Feature("Input")]
        	//[Requirement("Device.Device events (#205)")]
           	//[Requirement("UI.Help (#960)")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
			//[Requirement("Debugging.Application visualization (#620)")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			//[Requirement("Operational.Performance tuning (#1325)")]
			//[Requirement("Rendering.Video/image capture (#745)")]
        	//[Requirement("Device.Digital devices (#155)")]
        	//[Requirement("App Development.Event-based programming model (#1105)")]
           	sampleFramework.SetKeyboardCallback(new KeyboardCallback(this.MasterKeyEventHandler));
			
           	//[Feature("GUI")]
			//[Requirement("Device.Device events (#205)")]
			//[Requirement("Device.Digital devices (#155)")]
			sampleFramework.SetWndProcCallback(new WndProcCallback(this.MasterWndProcHandler));

			//[Feature("Input")]
        	//[Requirement("Debugging.Exception/error detection (#625)")]
        	//[Requirement("Device.Digital devices (#155)")]
        	//[Requirement("Device.Device events (#205)")]
        	//[Requirement("App Development.Event-based programming model (#1105)")]
			sampleFramework.SetMouseCallback(new MouseCallback(this.MasterMouseEventHandler));

			//[Feature("GUI")]
			//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			sampleFramework.SetCallbackInterface(this);
		}

		/// <summary>
		/// Runs the application
		/// </summary>
		/// <remarks>Make sure you call Run(), Shutdown() and then Dispose()</remarks>
		/// <returns>Exit code</returns>
		public int Run()
		{
			//[Feature("EC")]
            //[Requirement("Debugging.Exception/error detection (#625)")]
			try
			{                                                       
				// Show the cursor and clip it when in full screen
				//[Feature("GUI")]
				//[Requirement("Device.Head mounted displays (#195)")]
				//[Requirement("3D UI.Optical see-through HMD support (#910)")]
				//[Requirement("Device.Single monitor displays (#165)")]
				//[Requirement("Device.Multi-monitor displays (#190)")]
				sampleFramework.SetCursorSettings(true, false);

				// Initialize the sample framework and create the desired window and Direct3D 
				// device for the application. Calling each of these functions is optional, but they
				// allow you to set several options which control the behavior of the sampleFramework.
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				sampleFramework.Initialize( true, true, true ); // Parse the command line, handle the default hotkeys, and show msgboxes
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				sampleFramework.CreateWindow("Goblin");

				// Initialize
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				InitializeApplication(sampleFramework.Device);

				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				int monitorAdapterNumber = 0;
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				bool isWindowed = true;
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				int suggestedWidth = Framework.DefaultSizeWidth;
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				int suggestedHeight = Framework.DefaultSizeHeight;

				// Force an enumeration of all the monitors and monitor devices
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				Enumeration.Enumerate(this);

				// See if there is a monitor configured for 800x600. If so, assume
				// it is attached to a head-mounted display and use it as the default.
				// Otherwise, if the user specifies -adapter:# on the command-line then
				// use it as the default.  In both cases, change to full screen and ensure
				// the resolution is 800x600.
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				//[Requirement("Device.Head mounted displays (#195)")]
				//[Requirement("3D UI.Optical see-through HMD support (#910)")]
				DisplayMode adapterDesktopDisplayMode;
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				//[Requirement("Device.Head mounted displays (#195)")]
				//[Requirement("3D UI.Optical see-through HMD support (#910)")]
				for (int iAdapter = 0; iAdapter < Enumeration.AdapterInformationList.Count; iAdapter++)
				{                                                               
				    //[Feature("GUI")]
				    //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				    //[Requirement("Device.Head mounted displays (#195)")]
				    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
					EnumAdapterInformation adapterInfo = Enumeration.AdapterInformationList[iAdapter] as EnumAdapterInformation;
            
					// Get the desktop display mode of the adapter
				    //[Feature("GUI")]
				    //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				    //[Requirement("Device.Head mounted displays (#195)")]
				    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
					adapterDesktopDisplayMode = Manager.Adapters[(int)adapterInfo.AdapterOrdinal].CurrentDisplayMode;

				    //[Feature("GUI")]
				    //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				    //[Requirement("Device.Head mounted displays (#195)")]
				    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
                    //[Requirement("Device.Single monitor displays (#165)")]
                    //[Requirement("Device.Multi-monitor displays (#190)")]
					if ((adapterDesktopDisplayMode.Width == 800 &&
						adapterDesktopDisplayMode.Height == 600) ||             
						iAdapter == sampleFramework.OverridingAdapterOrdinal)   
					{                                                           
				        //[Feature("GUI")]
				        //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				        //[Requirement("Device.Head mounted displays (#195)")]
				        //[Requirement("3D UI.Optical see-through HMD support (#910)")]
                        //[Requirement("Device.Multi-monitor displays (#190)")]
                        //[Requirement("Device.Single monitor displays (#165)")]
						monitorAdapterNumber = iAdapter;                        

				        //[Feature("GUI")]
				        //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				        //[Requirement("Device.Head mounted displays (#195)")]
				        //[Requirement("3D UI.Optical see-through HMD support (#910)")]
                        //[Requirement("Device.Single monitor displays (#165)")]
                        //[Requirement("Device.Multi-monitor displays (#190)")]
                        isWindowed = false;                                     

				        //[Feature("GUI")]
				        //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				        //[Requirement("Device.Head mounted displays (#195)")]
				        //[Requirement("3D UI.Optical see-through HMD support (#910)")]
                        //[Requirement("Device.Single monitor displays (#165)")]
                        //[Requirement("Device.Multi-monitor displays (#190)")]
                        suggestedWidth = 800;                                   

				        //[Feature("GUI")]
				        //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				        //[Requirement("Device.Head mounted displays (#195)")]
				        //[Requirement("3D UI.Optical see-through HMD support (#910)")]
                        //[Requirement("Device.Single monitor displays (#165)")]
                        //[Requirement("Device.Multi-monitor displays (#190)")]
                        suggestedHeight = 600;                                  
					}                                                           
				}                                                               

				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				//[Requirement("Device.Head mounted displays (#195)")]
				//[Requirement("3D UI.Optical see-through HMD support (#910)")]
				sampleFramework.CreateDevice(	monitorAdapterNumber,
												isWindowed,                     
												suggestedWidth,                 
												suggestedHeight,                
												this);                          

				// Pass control to the sample framework for handling the message pump and 
				// dispatching render calls. The sample framework will call your FrameMove 
				// and FrameRender callback when there is idle time between handling window messages.
				//[Feature("GUI")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				sampleFramework.MainLoop();
			}
            //:block[Feature("EH")]
			//:block[Requirement("Debugging.Exception/error handling (#630)")]
			catch (Exception e)                                                 
			{                                                                   
				//[Requirement("Debugging.Exception/error handling (#630)")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				sampleFramework.DisplayErrorMessage(e);
			}                                                                   

			// Perform any application-level cleanup here. Direct3D device resources are released within the
			// appropriate callback functions and therefore don't require any cleanup code here.
			//[Feature("EH")]
			//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			//[Requirement("Debugging.Exception/error handling (#630)")]
			return sampleFramework.ExitCode;
		}

		/// <summary>
		/// Saves changed settings
		/// </summary>
		/// <remarks>Make sure you call Run(), Shutdown() and then Dispose()</remarks>
		public void Shutdown()
		{
			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			try
			{                                                                                       
				//save our device settings
				//[Feature("Persistence")]
				//[Feature("EC")]
				//[Requirement("Debugging.Exception/error detection (#625)")]
				//[Requirement("Configuration.Device configuration files (#135)")]
				if (inputMapper != null && inputMapper.HasChanged)
				{                                                                                   
					//[Feature("Logging")]
					//[Requirement("Debugging.Logging (#600)")]
					MyTrace.Log(TraceLevel.Info, "Serializing device config (change detected).");
					//[Feature("Persistence")]
					//[Requirement("Configuration.Device configuration files (#135)")]
					//[Requirement("Configuration.XML (#400)")]
					XmlSerializerHelper.Serialize("init_devices.xml", inputMapper);
				}                                                                                   
			}                                                                                       
            //:block[Feature("EH")]
			//:block[Requirement("Debugging.Exception/error handling (#630)")]
			catch(System.UnauthorizedAccessException e)                                             
			{                                                                                       
				//[Feature("Logging")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				//[Requirement("Debugging.Logging (#600)")]
				MyTrace.Log(TraceLevel.Warning,"init_devices.xml was NOT saved (you probably don't have it checked out): "+
					e.Message);                                                                     
			}                                                                                       
		}

		/// <summary>
		/// Releases resources
		/// </summary>
		public void Dispose()
		{
			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (appPlugins != null)
			{             
                //[Feature("Plugins")]                  
				//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
				//[Requirement("App Development.Dynamic application loading (#1145)")]
				for(int i = 0; i < appPlugins.Count; ++i)
				{                                           
                    //[Feature("Plugins")]                  
				    //[Requirement("Nonfunctional.Clean shutdown (#1405)")]
				    //[Requirement("App Development.Dynamic application loading (#1145)")]
					IApp appPlugin = (IApp) appPlugins[i];  
					
                    //[Feature("Plugins")]                  
    				//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
	    			//[Requirement("App Development.Dynamic application loading (#1145)")]
                    appPlugin.Dispose();

			        //[Feature("EC")]
			        //[Requirement("Debugging.Exception/error detection (#625)")]
					appPlugin = null;                       
				}                                           

			    //[Feature("EC")]
			    //[Requirement("Debugging.Exception/error detection (#625)")]
				appPlugins = null;
			}

			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (sampleFramework != null)
			{                                               
			    //[Feature("GUI")]
				//[Requirement("App Development.Object model (#1110)")]
				//[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
				//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
				sampleFramework.Dispose();
				
			    //[Feature("EC")]
			    //[Requirement("Debugging.Exception/error detection (#625)")]
				sampleFramework = null;
			}                                               

			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (nodeCamera != null)
			{                                               
    			//[Feature("GUI")]
				//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
				//[Requirement("Device.Single monitor displays (#165)")]
				//[Requirement("Device.Multi-monitor displays (#190)")]
				//[Requirement("Device.Head mounted displays (#195)")]
				//[Requirement("3D UI.Optical see-through HMD support (#910)")]
				//[Requirement("3D UI.Monoscopic display support (#915)")]
				nodeCamera.Dispose();                       

			    //[Feature("EC")]
			    //[Requirement("Debugging.Exception/error detection (#625)")]
                nodeCamera = null;
			}                                               

			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (inputMapper != null)
			{                                               
				// Release serial ports, sockets, etc. associated with input
				// devices and trackers
			    //[Feature("Input")]
				//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
				//[Requirement("Device.Device abstraction (#100)")]
				//[Requirement("Device.Dynamic device discovery (#105)")]
				inputMapper.Dispose();                      

			    //[Feature("EC")]
			    //[Requirement("Debugging.Exception/error detection (#625)")]
				inputMapper = null;                         
			}                                               
		}

        /// <summary>
        /// Called during device initialization, this code checks the device for some 
        /// minimum set of capabilities, and rejects those that don't pass by returning false.
        /// </summary>
        public bool IsDeviceAcceptable(Caps caps, Format adapterFormat, Format backBufferFormat, bool windowed)
        {
            // Skip back buffer formats that don't support alpha blending
            //[Feature("GUI")]
            //[Feature("EC")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            //[Requirement("Debugging.Exception/error detection (#625)")]
            if (!Manager.CheckDeviceFormat(caps.AdapterOrdinal, caps.DeviceType, adapterFormat,
                Usage.QueryPostPixelShaderBlending, ResourceType.Textures, backBufferFormat))   
                //[Feature("EH")]
            	//[Requirement("Debugging.Exception/error handling (#630)")]
                return false;                                                                   

            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            return true;
        }

        /// <summary>
        /// This callback function is called immediately before a device is created to allow the 
        /// application to modify the device settings. The supplied settings parameter 
        /// contains the settings that the framework has selected for the new device, and the 
        /// application can make any desired changes directly to this structure.  Note however that 
        /// the sample framework will not correct invalid device settings so care must be taken 
        /// to return valid device settings, otherwise creating the Device will fail.  
        /// </summary>
        public void ModifyDeviceSettings(DeviceSettings settings, Caps caps)
        {
            // If device doesn't support HW T&L or doesn't support 1.1 vertex shaders in HW 
            // then switch to SWVP.
            //[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
            if ( (!caps.DeviceCaps.SupportsHardwareTransformAndLight) ||
                (caps.VertexShaderVersion < new Version(1,1)) )                 
            {                                                                   
                //[Feature("EH")]
                //[Feature("GUI")]
                //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            	//[Requirement("Debugging.Exception/error handling (#630)")]
                settings.BehaviorFlags = CreateFlags.SoftwareVertexProcessing;
            }                                                                   
            //:block[Feature("GUI")]
            //:block[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            else                                                                
            {                                                                   
                //[Feature("GUI")]
                //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
                settings.BehaviorFlags = CreateFlags.HardwareVertexProcessing;
            }                                                                   

            // This application is designed to work on a pure device by not using 
            // any get methods, so create a pure device if supported and using HWVP.
            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            if ( (caps.DeviceCaps.SupportsPureDevice) &&
                ((settings.BehaviorFlags & CreateFlags.HardwareVertexProcessing) != 0 ) )
                //[Feature("GUI")]
                //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
                settings.BehaviorFlags |= CreateFlags.PureDevice;

            // Debugging vertex shaders requires either REF or software vertex processing 
            // and debugging pixel shaders requires REF.  
			#if(DEBUG_VS)                                                       
            //[Requirement("Debugging.Exception/error detection (#625)")]
            //[Requirement("Nonfunctional.Unused (#1400)")]
            if (settings.DeviceType != DeviceType.Reference )
            {
                //[Requirement("Debugging.Exception/error detection (#625)")]
                //[Requirement("Nonfunctional.Unused (#1400)")]
                settings.BehaviorFlags &= ~CreateFlags.HardwareVertexProcessing;
                //[Requirement("Debugging.Exception/error detection (#625)")]
                //[Requirement("Nonfunctional.Unused (#1400)")]
                settings.BehaviorFlags |= CreateFlags.SoftwareVertexProcessing;
            }
			#endif                                                              

			#if(DEBUG_PS)                                                       
            //[Feature("Debug")]
            //[Requirement("Nonfunctional.Unused (#1400)")]
            settings.DeviceType = DeviceType.Reference;
			#endif                                                              
        }

        /// <summary>
        /// This event will be fired immediately after the Direct3D device has been 
        /// created, which will happen during application initialization and windowed/full screen 
        /// toggles. This is the best location to create Pool.Managed resources since these 
        /// resources need to be reloaded whenever the device is destroyed. Resources created  
        /// here should be released in the Disposing event. 
        /// </summary>
        private void OnCreateDevice(object sender, DeviceEventArgs e)
        {
            // Initialize the stats font
            //[Feature("Stats")]
            //[Feature("Help")]
            //[Requirement("Operational.Frames per second display (#1315)")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            statsFont = ResourceCache.GetGlobalInstance().CreateFont(e.Device, 15, 0, FontWeight.Bold, 1, false, CharacterSet.Default,
                Precision.Default, FontQuality.Default, PitchAndFamily.FamilyDoNotCare | PitchAndFamily.DefaultPitch,                   
                "Arial");                                                                                                               
        }
        
        /// <summary>
        /// This event will be fired immediately after the Direct3D device has been 
        /// reset, which will happen after a lost device scenario. This is the best location to 
        /// create Pool.Default resources since these resources need to be reloaded whenever 
        /// the device is lost. Resources created here should be released in the OnLostDevice 
        /// event. 
        /// </summary>
        private void OnResetDevice(object sender, DeviceEventArgs e)
        {
            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            SurfaceDescription desc = e.BackBufferDescription;

            // Create a sprite to help batch calls when drawing many lines of text
            //[Feature("Help")]
			//[Requirement("Operational.Frames per second display (#1315)")]
			//[Requirement("UI.Help (#960)")]
            textSprite = new Sprite(e.Device);

			//Console.WriteLine("OnResetDevice");

            // Setup the camera's projection parameters

			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
            float aspectRatio = (float)desc.Width / (float)desc.Height;

			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
            dxFirstPersonCamera.SetProjectionParameters((float)Math.PI / 4, aspectRatio, 0.1f, 1000.0f);

			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
            e.Device.Transform.Projection = dxFirstPersonCamera.ProjectionMatrix;
			//camera.SetWindow(desc.Width, desc.Height);
			
			// Setup a light
            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			e.Device.Lights[0].Type = LightType.Point;

            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            e.Device.Lights[0].Position = new Vector3(-5.0f, 2.0f, 5.0f);

            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            e.Device.Lights[0].DiffuseColor = ColorValue.FromColor(System.Drawing.Color.Red);

            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            e.Device.Lights[0].Enabled = true;

			// Set all around ambient scene lighting to white so that the
			// the unaltered mesh material's ambient color is used
            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			e.Device.RenderState.Ambient = System.Drawing.Color.White;

			// Lighting must be true or else meshes will be drawn white
            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			e.Device.RenderState.Lighting = true;

			// Take this out to improve performance once the coor systems have been worked out
            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			e.Device.RenderState.CullMode = Cull.None;

			// Haven't determined if these flags need to be set
            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			e.Device.RenderState.FillMode = fillMode;
			//e.Device.RenderState.DitherEnable = true;
			//e.Device.RenderState.ZBufferEnable = true;
			//e.Device.RenderState.NormalizeNormals = true;
			//e.Device.RenderState.SpecularEnable = true;
			//e.Device.SamplerState[0].MagFilter = TextureFilter.Linear;
			//e.Device.SamplerState[0].MinFilter = TextureFilter.Linear;

            // Setup UI locations
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            hud.SetLocation(desc.Width-170, 0);

			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            hud.SetSize(170,170);
            
            //[Feature("SampleUI")]
            //[Requirement("Nonfunctional.Unused (#1400)")]
   	        sampleUi.SetLocation(desc.Width - 170, desc.Height - 350);

            //[Feature("SampleUI")]
            //[Requirement("Nonfunctional.Unused (#1400)")]
            sampleUi.SetSize(170, 300);

            //[Feature("GUI")]
			//[Requirement("Rendering.Scene graph (#735)")]
			//[Requirement("App Development.Object model (#1110)")]
			//[Requirement("Rendering.Dynamic scene geometry (#740)")]
			sceneGraph = new SceneGraph();

            //[Feature("GUI")]
			//[Requirement("Rendering.Scene graph (#735)")]
			sceneGraph.fillMode = fillMode;

			// Applications should add all the needed nodes to the scene graph
			//[Feature("EC")]
			//[Feature("Plugins")]
			//[Requirement("App Development.Event-based programming model (#1105)")]
			//[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			//[Requirement("Rendering.Dynamic scene geometry (#740)")]
			for(int i = 0; appPlugins != null && i < appPlugins.Count; ++i)
			{                                                               
				//[Feature("Plugins")]
			    //[Requirement("App Development.Event-based programming model (#1105)")]
			    //[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
			    //[Requirement("Rendering.Dynamic scene geometry (#740)")]
				IApp appPlugin = (IApp) appPlugins[i];

				//[Feature("Plugins")]
			    //[Requirement("App Development.Event-based programming model (#1105)")]
			    //[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
			    //[Requirement("Rendering.Dynamic scene geometry (#740)")]
				appPlugin.SceneGraphInit(e.Device);
			}                                                               

			// Optimize by combining all transformations
			//[Feature("GUI")]
			//[Feature("Opt")]
			//[Requirement("Rendering.Scene graph (#735)")]
			//[Requirement("Operational.Minimum frame rate of 15 fps (#1305)")]
			//[Requirement("Operational.Maximum user input latency of 1 second (#1310)")]
			//[Requirement("Operational.Target frame rate of 60 fps (#1300)")]
			sceneGraph.CombineTransformations(e.Device, Matrix.Identity);

			// Applications should add all the needed nodes to the scene graph
			//[Feature("EC")]
			//[Feature("Plugins")]
			//[Requirement("App Development.Event-based programming model (#1105)")]
			//[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			//[Requirement("Rendering.Dynamic scene geometry (#740)")]
			for(int i = 0; appPlugins != null && i < appPlugins.Count; ++i)
			{                                                               
				//[Feature("Plugins")]
			    //[Requirement("App Development.Event-based programming model (#1105)")]
			    //[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
			    //[Requirement("Rendering.Dynamic scene geometry (#740)")]
				IApp appPlugin = (IApp) appPlugins[i];

                //[Feature("Plugins")]
			    //[Requirement("App Development.Event-based programming model (#1105)")]
			    //[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
			    //[Requirement("Rendering.Dynamic scene geometry (#740)")]
				appPlugin.SceneGraphInited(e.Device);
			}                                                               
		}

        /// <summary>
        /// This event function will be called fired after the Direct3D device has 
        /// entered a lost state and before Device.Reset() is called. Resources created
        /// in the OnResetDevice callback should be released here, which generally includes all 
        /// Pool.Default resources. See the "Lost Devices" section of the documentation for 
        /// information about lost devices.
        /// </summary>
        private void OnLostDevice(object sender, EventArgs e)
        {
            //[Feature("EC")]
            //[Feature("Stats")]
            //[Feature("Help")]
            //[Requirement("Debugging.Exception/error detection (#625)")]
			//[Requirement("Operational.Frames per second display (#1315)")]
			//[Requirement("UI.Help (#960)")]
            if (textSprite != null)
            {                           
            	//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
				//[Requirement("Operational.Frames per second display (#1315)")]
				//[Requirement("UI.Help (#960)")]
                textSprite.Dispose();
                
                //[Feature("EC")]
                //[Requirement("Debugging.Exception/error detection (#625)")]
                textSprite = null;
            }                           
        }

        /// <summary>
        /// This callback function will be called immediately after the Direct3D device has 
        /// been destroyed, which generally happens as a result of application termination or 
        /// windowed/full screen toggles. Resources created in the OnCreateDevice callback 
        /// should be released here, which generally includes all Pool.Managed resources. 
        /// </summary>
        private void OnDestroyDevice(object sender, EventArgs e)
        {
			//[Feature("EC")]
			//[Feature("GUI")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			//[Requirement("Rendering.Scene graph (#735)")]
			//[Requirement("App Development.Object model (#1110)")]
			//[Requirement("Rendering.Dynamic scene geometry (#740)")]
		    //[Requirement("Configuration.Dynamic reconfiguration (#405)")]
			if (sceneGraph != null)
			{                           
				//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
				//[Requirement("Rendering.Scene graph (#735)")]
				//[Requirement("App Development.Object model (#1110)")]
				//[Requirement("Rendering.Dynamic scene geometry (#740)")]
				sceneGraph.Dispose();
				
    			//[Feature("EC")]
    			//[Requirement("Debugging.Exception/error detection (#625)")]
				sceneGraph = null;
			}                           
		}

        /// <summary>
        /// This callback function will be called once at the beginning of every frame. This is the
        /// best location for your application to handle updates to the scene, but is not 
        /// intended to contain actual rendering calls, which should instead be placed in the 
        /// OnFrameRender callback.  
        /// </summary>
		public void OnFrameMove(Device device, double appTime, float elapsedTime)
		{
			// Set device transforms
			//[Feature("Input")]
			//[Requirement("Device.Local device state (#125)")]
			//[Requirement("Device.Device abstraction (#100)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			inputMapper.Update(elapsedTime);

			//[Feature("GUI.Camera")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			if (!useTrackedCamera)
			{                                                           
				// Update the camera's position based on user input     
			    //[Feature("GUI.Camera")]
			    //[Requirement("Device.Single monitor displays (#165)")]
			    //[Requirement("Device.Multi-monitor displays (#190)")]
			    //[Requirement("Device.Head mounted displays (#195)")]
			    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
			    //[Requirement("3D UI.Monoscopic display support (#915)")]
			    //[Requirement("Device.Position and orientation trackers (#150)")]
			    //[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
				dxFirstPersonCamera.FrameMove(elapsedTime);             
			}                                                           

			//[Feature("EC")]
			//[Requirement("Rendering.Scene graph (#735)")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (sceneGraph != null)
				//[Feature("GUI")]
				//[Requirement("Rendering.Scene graph (#735)")]
				sceneGraph.FrameMove(device, elapsedTime);

			//[Feature("EC")]
			//[Feature("Plugins")]
			//[Requirement("App Development.Event-based programming model (#1105)")]
			//[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			for(int i = 0; appPlugins != null && i < appPlugins.Count; ++i)
			{                                                                   
				//[Feature("Plugins")]
			    //[Requirement("App Development.Event-based programming model (#1105)")]
			    //[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
				IApp appPlugin = (IApp) appPlugins[i];

                //[Feature("Plugins")]
			    //[Requirement("App Development.Event-based programming model (#1105)")]
			    //[Requirement("App Development.Direct access to Direct3D and Windows APIs (#1130)")]
				appPlugin.FrameMove(device, sampleFramework.FPS, elapsedTime);
			}                                                                   
		}

        /// <summary>
        /// This callback function will be called at the end of every frame to perform all the 
        /// rendering calls for the scene, and it will also be called if the window needs to be 
        /// repainted. After this function has returned, the sample framework will call 
        /// Device.Present to display the contents of the next buffer in the swap chain
        /// </summary>
        public void OnFrameRender(Device device, double appTime, float elapsedTime)
        {
			//UpdateFullscreen();

            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            //[Requirement("Rendering.Scene graph (#735)")]
            bool beginSceneCalled = false;

            // Clear the render target and the z-buffer 
            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            //[Requirement("Rendering.Scene graph (#735)")]
            device.Clear(ClearFlags.ZBuffer | ClearFlags.Target, 0x00000000, 1.0f, 0);

            //[Feature("EC")]
            //[Requirement("Debugging.Exception/error detection (#625)")]
            try
            {
                //[Feature("GUI")]
                //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
                //[Requirement("Rendering.Scene graph (#735)")]
                device.BeginScene();

                //[Feature("GUI")]
                //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
                //[Requirement("Rendering.Scene graph (#735)")]
                beginSceneCalled = true;

				//[Feature("GUI")]
				//[Feature("Opt")]
				//[Requirement("Operational.Minimum frame rate of 15 fps (#1305)")]
				//[Requirement("Operational.Maximum user input latency of 1 second (#1310)")]
				//[Requirement("Operational.Target frame rate of 60 fps (#1300)")]
				if (sceneGraph.fillMode != fillMode)
				{                          
			        //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
        			//[Requirement("Rendering.Scene graph (#735)")]
					//[Requirement("3D UI.Optical see-through HMD support (#910)")]
					//[Requirement("3D UI.Real-world object occlusion (#935)")]
					//[Requirement("Operational.Performance tuning (#1325)")]
					//[Requirement("Debugging.Application visualization (#620)")]
					device.RenderState.FillMode = fillMode;                             

			        //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
        			//[Requirement("Rendering.Scene graph (#735)")]
					//[Requirement("3D UI.Optical see-through HMD support (#910)")]
					//[Requirement("3D UI.Real-world object occlusion (#935)")]
					//[Requirement("Operational.Performance tuning (#1325)")]
					//[Requirement("Debugging.Application visualization (#620)")]
                    sceneGraph.fillMode = fillMode;                                     
				}                                                                       

				//[Requirement("Device.Position and orientation trackers (#150)")]
				//[Requirement("Device.Single monitor displays (#165)")]
				//[Requirement("Device.Multi-monitor displays (#190)")]
				//[Requirement("Device.Head mounted displays (#195)")]
				//[Requirement("3D UI.Optical see-through HMD support (#910)")]
				//[Requirement("3D UI.Monoscopic display support (#915)")]
				device.Transform.Projection = dxFirstPersonCamera.ProjectionMatrix;

				//[Feature("EC")]
				//[Requirement("Rendering.Scene graph (#735)")]
				//[Requirement("Debugging.Exception/error detection (#625)")]
				if (sceneGraph != null)
					//[Feature("GUI")]
					//[Requirement("Rendering.Scene graph (#735)")]
					sceneGraph.Render(device, Vector3.Empty, null);

                // Show frame rate
                //[Feature("Stats")]
                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                //[Requirement("Operational.Frames per second display (#1315)")]
		       	//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
                RenderText();

                // Show UI
				//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
				//[Requirement("Device.Single monitor displays (#165)")]
				//[Requirement("Device.Multi-monitor displays (#190)")]
				//[Requirement("Device.Position and orientation trackers (#150)")]
				//[Requirement("Device.Head mounted displays (#195)")]
				//[Requirement("3D UI.Optical see-through HMD support (#910)")]
				//[Requirement("3D UI.Monoscopic display support (#915)")]
                hud.OnRender(elapsedTime);
                //sampleUi.OnRender(elapsedTime);
			}                                                                           
            finally                                                                     
            {                                                                           
		        //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		        //[Requirement("Rendering.Scene graph (#735)")]
                if (beginSceneCalled)
    		        //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
	    	        //[Requirement("Rendering.Scene graph (#735)")]
                    device.EndScene();
            }                                                                           

			//[Feature("ScreenCapture")]
			//[Requirement("Rendering.Video/image capture (#745)")]
			if (doPrintScreen)
			{                                                                           
				// BMP has the best resolution
    			//[Feature("ScreenCapture")]
	    		//[Requirement("Rendering.Video/image capture (#745)")]
				SaveScreenshot(device, "screenshot.bmp");

    			//[Feature("ScreenCapture")]
	    		//[Requirement("Rendering.Video/image capture (#745)")]
				doPrintScreen = false;
			}                                                                           
        }

        /// <summary>
        /// Render the help and statistics text. This function uses the Font object for 
        /// efficient text rendering.
        /// </summary>
        private void RenderText()
        {
            //[Feature("Stats")]
            //[Feature("Help")]
      	    //[Requirement("Operational.Frames per second display (#1315)")]
       	    //[Requirement("UI.Help (#960)")]
       	    //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            TextHelper txtHelper = new TextHelper(statsFont, textSprite, 15);

            // Output statistics
            //[Feature("Stats")]
            //[Feature("Help")]
      	    //[Requirement("Operational.Frames per second display (#1315)")]
       	    //[Requirement("UI.Help (#960)")]
       	    //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            txtHelper.Begin();

            //[Feature("Stats")]
            //[Requirement("Operational.Frames per second display (#1315)")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            txtHelper.SetInsertionPoint(5,5);

            //[Feature("Stats")]
            //[Requirement("Operational.Frames per second display (#1315)")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            txtHelper.SetForegroundColor(System.Drawing.Color.Yellow);

            //[Feature("Stats")]
            //[Requirement("Operational.Frames per second display (#1315)")]
            txtHelper.DrawTextLine(sampleFramework.FrameStats);

            //[Feature("Stats")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            txtHelper.DrawTextLine(sampleFramework.DeviceStats);

            //[Feature("Stats")]
            //[Requirement("Nonfunctional.Unused (#1400)")]
            txtHelper.SetForegroundColor(System.Drawing.Color.White);
            
			// Draw help
            //[Feature("Help")]
			//[Requirement("UI.Help (#960)")]
            if (isHelpShowing)
            {
                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height-15*6);

                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.SetForegroundColor(System.Drawing.Color.DarkOrange);

                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.DrawTextLine("Controls (F1 to hide):");

                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.SetInsertionPoint(40, sampleFramework.BackBufferSurfaceDescription.Height-15*5);

                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.DrawTextLine("Help Item Misc: X");

                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.DrawTextLine("Quit: Esc");

                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.DrawTextLine("Hide help: F1");
            }
            //:block[Feature("Help")]
            //:block[Requirement("UI.Help (#960)")]
            else
            {
                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height-15*2);

                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.SetForegroundColor(System.Drawing.Color.White);       

                //[Feature("Help")]
                //[Requirement("UI.Help (#960)")]
                txtHelper.DrawTextLine("Press F1 for help");                    
            }

            //[Feature("Stats")]
            //[Feature("Help")]
            //[Requirement("UI.Help (#960)")]
            //[Requirement("Operational.Frames per second display (#1315)")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            txtHelper.End();                                                    
        }

        /// <summary>
        /// As a convenience, the sample framework inspects the incoming windows messages for
        /// keystroke messages and decodes the message parameters to pass relevant keyboard
        /// messages to the application.  The framework does not remove the underlying keystroke 
        /// messages, which are still passed to the application's MsgProc callback.
        /// </summary>
        private void MasterKeyEventHandler(System.Windows.Forms.Keys key, bool isKeyDown, bool isKeyUp)
        {
            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            if (isKeyDown)
            {                                                       
                //[Feature("GUI")]
                //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
                switch(key)
                {                                                   
                	//:block[Requirement("UI.Help (#960)")]
                    //:block[Feature("Help")]
                    //:block[Feature("Stats")]
                    case System.Windows.Forms.Keys.F1:
                	    //[Requirement("UI.Help (#960)")]
                        //[Feature("Help")]
                        //[Feature("Stats")]
                        isHelpShowing = !isHelpShowing;
                        break;

                    //:block[Feature("GUI.Camera")]
					//:block[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
					//:block[Requirement("Device.Single monitor displays (#165)")]
					//:block[Requirement("Device.Multi-monitor displays (#190)")]
					//:block[Requirement("Device.Position and orientation trackers (#150)")]
					//:block[Requirement("Device.Head mounted displays (#195)")]
					//:block[Requirement("3D UI.Optical see-through HMD support (#910)")]
					//:block[Requirement("3D UI.Monoscopic display support (#915)")]
					case System.Windows.Forms.Keys.F4:

                        //[Feature("GUI.Camera")]
					    //[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
					    //[Requirement("Device.Single monitor displays (#165)")]
					    //[Requirement("Device.Multi-monitor displays (#190)")]
					    //[Requirement("Device.Position and orientation trackers (#150)")]
					    //[Requirement("Device.Head mounted displays (#195)")]
					    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
					    //[Requirement("3D UI.Monoscopic display support (#915)")]
                        OnUseTrackedCameraClicked(null, null);
						break;
						
					//:block[Feature("GUI")]
					//:block[Requirement("Debugging.Application visualization (#620)")]
					case System.Windows.Forms.Keys.B:
						//[Feature("EC")]
						//[Requirement("Debugging.Exception/error detection (#625)")]
						//[Requirement("Debugging.Application visualization (#620)")]
						if (sceneGraph != null)
							//[Feature("GUI")]
							//[Requirement("Debugging.Application visualization (#620)")]
							sceneGraph.showBoundingVolumes = !sceneGraph.showBoundingVolumes;
						break;
						
					//:block[Feature("GUI.AR")]
					//:block[Requirement("3D UI.Optical see-through HMD support (#910)")]
					//:block[Requirement("Device.Single monitor displays (#165)")]
					//:block[Requirement("Device.Multi-monitor displays (#190)")]
					//:block[Requirement("Device.Head mounted displays (#195)")]
					//:block[Requirement("3D UI.Monoscopic display support (#915)")]
					//:block[Requirement("Debugging.Application visualization (#620)")]
					//:block[Requirement("Operational.Performance tuning (#1325)")]
                    case System.Windows.Forms.Keys.R:
						//[Feature("GUI.AR")]
						//[Requirement("3D UI.Optical see-through HMD support (#910)")]
						if (fillMode == FillMode.Point)
						{                                           
						    //[Feature("GUI.AR")]
						    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
							fillMode = FillMode.Solid;

    						//[Feature("GUI.AR")]
	    					//[Requirement("3D UI.Optical see-through HMD support (#910)")]
                            sceneGraph.RootNode.RenderRealAsBlack = true;
						}                                           

					    //:block[Feature("GUI")]
						//:block[Requirement("Device.Single monitor displays (#165)")]
						//:block[Requirement("Device.Multi-monitor displays (#190)")]
						//:block[Requirement("Device.Head mounted displays (#195)")]
						//:block[Requirement("3D UI.Monoscopic display support (#915)")]
						else if (fillMode == FillMode.Solid && sceneGraph.RootNode.RenderRealAsBlack)
						{                                           
					        //[Feature("GUI")]
						    //[Requirement("Device.Single monitor displays (#165)")]
						    //[Requirement("Device.Multi-monitor displays (#190)")]
						    //[Requirement("Device.Head mounted displays (#195)")]
						    //[Requirement("3D UI.Monoscopic display support (#915)")]
							sceneGraph.RootNode.RenderRealAsBlack = false;
						}                
						
					    //:block[Feature("GUI")]
						//:block[Requirement("Debugging.Application visualization (#620)")]
						//:block[Requirement("Operational.Performance tuning (#1325)")]
						else if (fillMode == FillMode.Solid)        
						{                                           
					        //[Feature("GUI")]
						    //[Requirement("Debugging.Application visualization (#620)")]
						    //[Requirement("Operational.Performance tuning (#1325)")]
							fillMode = FillMode.WireFrame;
						}                                           
						
					    //:block[Feature("GUI")]
						//:block[Requirement("Debugging.Application visualization (#620)")]
						//:block[Requirement("Operational.Performance tuning (#1325)")]
						else if (fillMode == FillMode.WireFrame)    
						{                                           
					        //[Feature("GUI")]
						    //[Requirement("Debugging.Application visualization (#620)")]
						    //[Requirement("Operational.Performance tuning (#1325)")]
							fillMode = FillMode.Point;
						}                                           

						break;

					// Ideally, we would use the PRINT SCREEN key (VK_SNAPSHOT).
					// It requires a low-level windows hook (WH_KEYBOARD_LL).
					//:block[Feature("ScreenCapture")]
					//:block[Requirement("Rendering.Video/image capture (#745)")]
					case System.Windows.Forms.Keys.P:
					    //[Feature("ScreenCapture")]
					    //[Requirement("Rendering.Video/image capture (#745)")]
						doPrintScreen = true;
						break;
				}                                                   
            }

			//[Feature("EC")]
        	//[Requirement("Debugging.Exception/error detection (#625)")]
			if (keyEvent != null)
			    //[Feature("Input")]
        	    //[Requirement("Device.Digital devices (#155)")]
        	    //[Requirement("Device.Device events (#205)")]
        	    //[Requirement("App Development.Event-based programming model (#1105)")]
				keyEvent(key, isKeyDown, isKeyUp);
        }

		public void MasterMouseEventHandler(bool leftButtonDown, bool rightButtonDown, bool middleButtonDown, bool sideButton1Down, bool sideButton2Down, int mouseWheelDelta, int x, int y)
		{
			//[Feature("EC")]
        	//[Requirement("Debugging.Exception/error detection (#625)")]
			if (mouseEvent != null)
			    //[Feature("Input")]
        	    //[Requirement("Device.Digital devices (#155)")]
        	    //[Requirement("Device.Device events (#205)")]
        	    //[Requirement("App Development.Event-based programming model (#1105)")]
				mouseEvent(leftButtonDown, rightButtonDown, middleButtonDown, sideButton1Down, sideButton2Down, mouseWheelDelta, x, y);
		}

        /// <summary>
        /// Before handling window messages, the sample framework passes incoming windows 
        /// messages to the application through this callback function. If the application sets 
        /// noFurtherProcessing to true, the sample framework will not process the message
        /// </summary>
        public IntPtr MasterWndProcHandler(IntPtr hWnd, NativeMethods.WindowMessage msg, IntPtr wParam, IntPtr lParam, ref bool noFurtherProcessing)
        {
            // Give the dialog a chance to handle the message first
            //[Feature("GUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            noFurtherProcessing = hud.MessageProc(hWnd, msg, wParam, lParam);

            //[Feature("GUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            if (noFurtherProcessing)
                //[Feature("GUI")]
            	//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
                return IntPtr.Zero;

            //[Feature("SampleUI")]
            //[Requirement("Nonfunctional.Unused (#1400)")]
            noFurtherProcessing = sampleUi.MessageProc(hWnd, msg, wParam, lParam);

            //[Feature("SampleUI")]
            //[Requirement("Nonfunctional.Unused (#1400)")]
            if (noFurtherProcessing)
                //[Feature("SampleUI")]
            	//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
                return IntPtr.Zero;

            // Pass all remaining windows messages to camera so it can respond to user input
            //[Feature("GUI.Camera")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
            dxFirstPersonCamera.HandleMessages(hWnd, msg, wParam, lParam);

			//[Feature("EC")]
        	//[Requirement("Debugging.Exception/error detection (#625)")]
			if (wndProcEvent != null)
			    //[Feature("GUI")]
			    //[Requirement("Nonfunctional.Unused (#1400)")]
				wndProcEvent(hWnd, msg, wParam, lParam, ref noFurtherProcessing);

            //[Feature("GUI")]
            //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
            return IntPtr.Zero;
        }

        /// <summary>
        /// Initializes the application
        /// </summary>
        public void InitializeApplication(Device device)
        {
            //[Feature("GUI")]
            //[Feature("SampleUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
			//[Requirement("Nonfunctional.Unused (#1400)")]
            int y = 10;
            
            // Initialize the HUD

            //[Feature("GUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            Button fullScreen = hud.AddButton(ToggleFullscreen,"Toggle full screen", 35, y, 125,22);

            //[Feature("GUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            Button toggleRef = hud.AddButton(ToggleReference,"Toggle reference (F3)", 35, y += 24, 125,22);

            //[Feature("GUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            Button changeDevice = hud.AddButton(ChangeDevice,"Change device (F2)", 35, y += 24, 125,22);

            //[Feature("GUI.Camera")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			trackedCameraBtn = hud.AddButton(UseTrackedCamera, "Use tracked camera", 35, y += 24, 125,22);

            // Hook the button events for when these items are clicked
            //[Feature("GUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            fullScreen.Click += new EventHandler(OnFullscreenClicked);

            //[Feature("GUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            toggleRef.Click += new EventHandler(OnRefClicked);

            //[Feature("GUI")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
            changeDevice.Click += new EventHandler(OnChangeDeviceClicked);

            //[Feature("GUI.Camera")]
			//[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
			//[Requirement("Device.Position and orientation trackers (#150)")]
			trackedCameraBtn.Click += new EventHandler(OnUseTrackedCameraClicked);

            // Now add the sample specific UI
			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            y = 10;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int ComboBox1 = ChangeDevice + 1;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int CheckBox1 = ChangeDevice + 2;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int CheckBox2 = ChangeDevice + 3;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int Radiobutton1 = ChangeDevice + 4;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int Radiobutton2 = ChangeDevice + 5;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int Radiobutton3 = ChangeDevice + 6;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int Button1 = ChangeDevice + 7;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int Button2 = ChangeDevice + 8;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int Radiobutton4 = ChangeDevice + 9;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int Radiobutton5 = ChangeDevice + 10;

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            const int SliderControl = ChangeDevice + 11;


			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            ComboBox cb1 = sampleUi.AddComboBox(ComboBox1, 35, y += 24, 125, 22);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            for (int i = 0; i < 50; i++) cb1.AddItem("Item#" + i.ToString(), null);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddCheckBox(CheckBox1, "Checkbox1", 35, y+=24, 125,22, false);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddCheckBox(CheckBox2, "Checkbox2", 35, y+=24, 125,22, false);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddRadioButton(Radiobutton1, 1, "Radio1G1", 35, y+=24, 125, 22, true);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddRadioButton(Radiobutton2, 1, "Radio2G1", 35, y+=24, 125, 22, false);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddRadioButton(Radiobutton3, 1, "Radio3G1", 35, y+=24, 125, 22, false);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddButton(Button1, "Button1", 35, y+=24, 125, 22);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddButton(Button2, "Button2", 35, y+=24, 125, 22);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddRadioButton(Radiobutton4, 2, "Radio1G2", 35, y+=24, 125, 22, true);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddRadioButton(Radiobutton5, 2, "Radio2G2", 35, y+=24, 125, 22, false);

			//[Requirement("Nonfunctional.Unused (#1400)")]
            //[Feature("SampleUI")]
            sampleUi.AddSlider(SliderControl, 50,y+=24, 100, 22);
			
			/*
			 * 
			 * TODO: the list of types given to Deserialize should really be gotten from
			 * the application, since they're the one who knows what device classes to read in
			 * 
			 * */

			//ConfigurationSettings.GetConfig("Input Device Configuration");
			
			//[Feature("Persistence")]
			//[Requirement("Configuration.Device configuration files (#135)")]
			string path = MyUtility.MyFindMediaFile("init_devices.xml");

            //[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (path != null)
			{
				//[Feature("Persistence")]
				//[Requirement("Configuration.Device configuration files (#135)")]
				//[Requirement("Configuration.XML (#400)")]
				inputMapper = (InputDeviceMapper)XmlSerializerHelper.Deserialize(path,typeof(InputDeviceMapper), new Type[]{typeof(InterSense)});
				
                //[Feature("EC")]
				//[Requirement("Debugging.Exception/error detection (#625)")]
				if(inputMapper == null)
				{
					//[Feature("Logging")]
					//[Requirement("Debugging.Logging (#600)")]
					//[Requirement("Debugging.Exception/error handling (#630)")]
					MyTrace.Log(TraceLevel.Error,"could not load InputDeviceMapper from init_devices.xml (make sure this file exists)");

					//[Feature("EH")]
                    //[Requirement("Debugging.Exception/error handling (#630)")]
					return;
				}
			}

			//[Feature("Plugins")]
			//[Requirement("App Development.Dynamic application loading (#1145)")]
			loadAppPlugins();
		}

        [Requirement("App Development.Dynamic application loading (#1145)")]
		[Feature("Plugins")]
		public void loadAppPlugins()
		{
			// Find out the executing assembly information
			System.Reflection.Assembly executingAssembly = System.Reflection.Assembly.GetExecutingAssembly();

			string exeDir = System.IO.Path.GetDirectoryName(executingAssembly.Location);

			loadAppPlugins(exeDir);
			loadAppPlugins(Path.Combine(exeDir, "Engine"));
		}

		public void loadAppPlugins(string directory)
		{
			//[Feature("Plugins")]
            //[Requirement("App Development.Dynamic application loading (#1145)")]
			string[] appPluginPaths = Directory.GetFiles(directory, "Goblin.Apps.*.dll");

            //[Feature("Plugins")]
            //[Requirement("App Development.Dynamic application loading (#1145)")]
			foreach(string appPlugin in appPluginPaths)
			{
                //[Feature("Plugins")]
                //[Requirement("App Development.Dynamic application loading (#1145)")]
				loadAppPlugin(appPlugin);
			}

			//[Feature("EC")]
			//[Feature("Plugins")]
			//[Requirement("App Development.Event-based programming model (#1105)")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			for(int i = 0; appPlugins != null && i < appPlugins.Count; ++i)
			{
				//[Feature("Plugins")]
                //[Requirement("App Development.Event-based programming model (#1105)")]
				IApp appPlugin = (IApp) appPlugins[i];

                //[Feature("Plugins")]
                //[Requirement("App Development.Event-based programming model (#1105)")]
				appPlugin.Init(this);
			}
		}

		public void loadAppPlugin(string pathPlugin)
		{
			//[Feature("PreCond")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (pathPlugin == null || pathPlugin.Length == 0)
			    //[Feature("EH")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return;

		    //[Requirement("App Development.Dynamic application loading (#1145)")]
		    //[Feature("Plugins")]
			string type = Path.GetFileNameWithoutExtension(pathPlugin);

		    //[Requirement("App Development.Dynamic application loading (#1145)")]
		    //[Feature("Plugins")]
			object objApp = CreateInstance(pathPlugin, type, true);

			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (objApp == null)
			{
				//[Feature("Logging")]
				//[Requirement("Debugging.Logging (#600)")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				MyTrace.Log(TraceLevel.Error, "Failed to load app plugin: '{0}'.",
					type);

                //[Feature("EH")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return;
			}
            //:block[Feature("EC")]
			//:block[Requirement("Debugging.Exception/error detection (#625)")]
			else if (!(objApp is IApp))
			{                                                                               
				//[Feature("Logging")]
				//[Requirement("Debugging.Logging (#600)")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				MyTrace.Log(TraceLevel.Error,
					"Failed to load app plugin: '{0}': Doesn't support IApp interface.",    
					type);
            	//[Feature("EH")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return;
			}                                                                               
			
		    //[Requirement("App Development.Dynamic application loading (#1145)")]
		    //[Feature("Plugins")]
			if (appPlugins == null)
		        //[Requirement("App Development.Dynamic application loading (#1145)")]
		        //[Feature("Plugins")]
                appPlugins = new ArrayList();

		    //[Requirement("App Development.Dynamic application loading (#1145)")]
		    //[Feature("Plugins")]
			appPlugins.Add(objApp);
		}

		/// <summary>
		/// Creates an instance of the type whose name is specified, using the named assembly and
		/// default constructor (same as Activator.CreateInstance). For some reason,
		/// Activator.CreateInstance() didn't work.
		/// </summary>
		/// <param name="assemblyName">Name of the assembly (without .dll) or full path to the assembly (with .dll).</param>
		/// <param name="typeName">Name of the type to create.</param>
		/// <returns></returns>
		public static Object CreateInstance(string assemblyName, string typeName, bool reportErrors)
		{
			//[Feature("Plugins")]
            //[Requirement("App Development.Dynamic application loading (#1145)")]
			Assembly assembly = null;

			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			try
			{
				//[Feature("Plugins")]
				//[Requirement("App Development.Dynamic application loading (#1145)")]
				if (System.IO.Path.GetDirectoryName(assemblyName) == "")
				{
				    //[Feature("Plugins")]
				    //[Requirement("App Development.Dynamic application loading (#1145)")]
					assembly =
						System.Reflection.Assembly.LoadWithPartialName(assemblyName);
				}
				//:block[Feature("Plugins")]
				//:block[Requirement("App Development.Dynamic application loading (#1145)")]
				else
				{
				    //[Feature("Plugins")]
				    //[Requirement("App Development.Dynamic application loading (#1145)")]
					assembly =
						System.Reflection.Assembly.LoadFile(assemblyName);
				}
			}
            //:block[Feature("EH")]
			//:block[Requirement("Debugging.Exception/error handling (#630)")]
			catch(Exception ex)
			{
				//[Feature("Logging")]
				//[Requirement("Debugging.Logging (#600)")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				if (reportErrors)
				{
				    //[Feature("Logging")]
				    //[Requirement("Debugging.Logging (#600)")]
				    //[Requirement("Debugging.Exception/error handling (#630)")]
					MyTrace.Log(TraceLevel.Error,
						"Failed to create type '{0}' because assembly load failed for '{1}'.",
						typeName,
						assemblyName);

				    //[Feature("Logging")]
				    //[Requirement("Debugging.Logging (#600)")]
				    //[Requirement("Debugging.Exception/error handling (#630)")]
					MyTrace.Log(TraceLevel.Error, ex.ToString());                       
				}                                                                       
				//[Feature("EH")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return null;
			}

			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (assembly == null)
			{
				//[Feature("Logging")]
				//[Requirement("Debugging.Logging (#600)")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				if (reportErrors)
				{
				    //[Feature("Logging")]
				    //[Requirement("Debugging.Logging (#600)")]
				    //[Requirement("Debugging.Exception/error handling (#630)")]
					MyTrace.Log(TraceLevel.Error,                                       
						"Failed to create type '{0}' because assembly load failed for '{1}' (unknown reason).",
						typeName,                                                       
						assemblyName);                                                  
				}                                                                       
				//[Feature("EH")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return null;
			}                                                                           

			// Create an instance of the type using the default constructor
			//[Feature("Plugins")]
            //[Requirement("App Development.Dynamic application loading (#1145)")]
			return assembly.CreateInstance(typeName);
		}

        /// <summary>Called when the change device button is clicked</summary>
        [Feature("GUI")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		[Requirement("Configuration.Dynamic reconfiguration (#405)")]
        private void OnChangeDeviceClicked(object sender, EventArgs e)
        {
            sampleFramework.ShowSettingsDialog(!sampleFramework.IsD3DSettingsDialogShowing);
        }

		/// <summary>Called when the change device button is clicked</summary>
		[Feature("GUI.Camera")]
		[Requirement("Device.Single monitor displays (#165)")]
		[Requirement("Device.Multi-monitor displays (#190)")]
		[Requirement("Device.Head mounted displays (#195)")]
		[Requirement("3D UI.Optical see-through HMD support (#910)")]
		[Requirement("3D UI.Monoscopic display support (#915)")]
		[Requirement("Device.Position and orientation trackers (#150)")]
		[Requirement("Configuration.Dynamic device reconfiguration (#130)")]
		[Requirement("Configuration.Dynamic reconfiguration (#405)")]
		private void OnUseTrackedCameraClicked(object sender, EventArgs e)
		{
			useTrackedCamera = !useTrackedCamera;
		}

        /// <summary>Called when the full screen button is clicked</summary>
		[Feature("GUI.Camera")]
		[Requirement("Device.Single monitor displays (#165)")]
		[Requirement("Device.Multi-monitor displays (#190)")]
		[Requirement("Device.Head mounted displays (#195)")]
		[Requirement("3D UI.Optical see-through HMD support (#910)")]
		[Requirement("3D UI.Monoscopic display support (#915)")]
		[Requirement("Device.Position and orientation trackers (#150)")]
		[Requirement("Configuration.Dynamic reconfiguration (#405)")]
        private void OnFullscreenClicked(object sender, EventArgs e)
        {
			//the only thing that was originally in the function!
			sampleFramework.ToggleFullscreen();
			UpdateFullscreen();
		}

		[Feature("GUI.Camera")]
		private	void UpdateFullscreen()
		{
		    //[Requirement("Device.Single monitor displays (#165)")]
		    //[Requirement("Device.Multi-monitor displays (#190)")]
		    //[Requirement("Device.Head mounted displays (#195)")]
		    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
		    //[Requirement("3D UI.Monoscopic display support (#915)")]
		    //[Requirement("Device.Position and orientation trackers (#150)")]
		    //[Requirement("Configuration.Dynamic reconfiguration (#405)")]
			SurfaceDescription desc	= sampleFramework.BackBufferSurfaceDescription;

			//FOV for HMD is 28deg (Horizontal)
			//float fovHMD = 27f;
		    //[Requirement("Device.Single monitor displays (#165)")]
		    //[Requirement("Device.Multi-monitor displays (#190)")]
		    //[Requirement("Device.Head mounted displays (#195)")]
		    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
		    //[Requirement("3D UI.Monoscopic display support (#915)")]
		    //[Requirement("Device.Position and orientation trackers (#150)")]
		    //[Requirement("Configuration.Dynamic reconfiguration (#405)")]
			float fovSonyCamera = 44f;

			//new stuff	(Benko)
			//see what are the current device settings:
		    //[Requirement("Device.Single monitor displays (#165)")]
		    //[Requirement("Device.Multi-monitor displays (#190)")]
		    //[Requirement("Device.Head mounted displays (#195)")]
		    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
		    //[Requirement("3D UI.Monoscopic display support (#915)")]
		    //[Requirement("Device.Position and orientation trackers (#150)")]
		    //[Requirement("Configuration.Dynamic reconfiguration (#405)")]
			float fov, aspectRatio;

			//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			//[Requirement("Device.Single monitor displays (#165)")]
			//[Requirement("Device.Multi-monitor displays (#190)")]
			//[Requirement("Device.Head mounted displays (#195)")]
			//[Requirement("3D UI.Optical see-through HMD support (#910)")]
			//[Requirement("3D UI.Monoscopic display support (#915)")]
			if (!sampleFramework.IsWindowed)
			{
				// Screen -- HMD/camera
			    //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			    //[Requirement("Device.Single monitor displays (#165)")]
			    //[Requirement("Device.Multi-monitor displays (#190)")]
			    //[Requirement("Device.Head mounted displays (#195)")]
			    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
			    //[Requirement("3D UI.Monoscopic display support (#915)")]
				aspectRatio	= 4f/3f;

			    //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			    //[Requirement("Device.Single monitor displays (#165)")]
			    //[Requirement("Device.Multi-monitor displays (#190)")]
			    //[Requirement("Device.Head mounted displays (#195)")]
			    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
			    //[Requirement("3D UI.Monoscopic display support (#915)")]
                fov	= (fovSonyCamera*((float)Math.PI /	180f) /	aspectRatio);
				//Console.WriteLine("Full	screen");
			}
			//:block[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			//:block[Requirement("Device.Single monitor displays (#165)")]
			//:block[Requirement("Device.Multi-monitor displays (#190)")]
			//:block[Requirement("3D UI.Monoscopic display support (#915)")]
			else
			{
				// Windowed -- regular	
			    //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			    //[Requirement("Device.Single monitor displays (#165)")]
			    //[Requirement("Device.Multi-monitor displays (#190)")]
			    //[Requirement("3D UI.Monoscopic display support (#915)")]
				aspectRatio	= (float)desc.Width	/ (float)desc.Height;

			    //[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			    //[Requirement("Device.Single monitor displays (#165)")]
			    //[Requirement("Device.Multi-monitor displays (#190)")]
			    //[Requirement("3D UI.Monoscopic display support (#915)")]
                fov	= (float)Math.PI / 4f;
				//Console.WriteLine("Windowed");
			}
			
		    //[Requirement("Device.Single monitor displays (#165)")]
		    //[Requirement("Device.Multi-monitor displays (#190)")]
		    //[Requirement("Device.Head mounted displays (#195)")]
		    //[Requirement("3D UI.Optical see-through HMD support (#910)")]
		    //[Requirement("3D UI.Monoscopic display support (#915)")]
		    //[Requirement("Device.Position and orientation trackers (#150)")]
		    //[Requirement("Configuration.Dynamic reconfiguration (#405)")]
			dxFirstPersonCamera.SetProjectionParameters(fov, aspectRatio, 0.1f,	1000.0f);
		}

        /// <summary>Called when the ref button is clicked</summary>
        [Feature("GUI")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
        private void OnRefClicked(object sender, EventArgs e)
        {
            sampleFramework.ToggleReference();
        }

		private void SaveScreenshot(Device device, string filename)
		{
            //[Feature("ScreenCapture")]
            //[Requirement("Rendering.Video/image capture (#745)")]
			string ext = Path.GetExtension(filename);

            //[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (ext.Length < 2)
			{
				//[Feature("Logging")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				//[Requirement("Debugging.Logging (#600)")]
				MyTrace.Log(TraceLevel.Error, "Invalid image file format requested: "
					+ ext);

                //[Feature("EH")]
                //[Requirement("Debugging.Exception/error handling (#630)")]
				return;
			}

            //[Feature("ScreenCapture")]
            //[Requirement("Rendering.Video/image capture (#745)")]
			ext = char.ToUpper(ext[1]) + ext.Substring(2);

            //[Feature("ScreenCapture")]
            //[Requirement("Rendering.Video/image capture (#745)")]
			ImageFileFormat format = (ImageFileFormat) (-1);

            //[Feature("ScreenCapture")]
            //[Requirement("Rendering.Video/image capture (#745)")]
			for(int cur = (int) ImageFileFormat.Bmp;
				cur < (int) ImageFileFormat.Pfm;
				++cur)
			{
                //[Feature("ScreenCapture")]
                //[Requirement("Rendering.Video/image capture (#745)")]
				ImageFileFormat curFormat = (ImageFileFormat) cur;

                //[Feature("ScreenCapture")]
                //[Requirement("Rendering.Video/image capture (#745)")]
				if (curFormat.ToString() == ext)
				{
                    //[Feature("ScreenCapture")]
                    //[Requirement("Rendering.Video/image capture (#745)")]
					format = curFormat;
					break;
				}
			}

			//[Requirement("Debugging.Exception/error detection (#625)")]
			//[Feature("EC")]
			if (format == (ImageFileFormat) (-1))
			{
				//[Feature("Logging")]
				//[Requirement("Debugging.Logging (#600)")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				MyTrace.Log(TraceLevel.Error, "Invalid image file format requested: "
					+ ext);
				//[Feature("EH")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return;
			}

            //[Feature("ScreenCapture")]
            //[Requirement("Rendering.Video/image capture (#745)")]
			Surface backbuffer = device.GetBackBuffer(0, 0, BackBufferType.Mono);

            //[Feature("ScreenCapture")]
            //[Requirement("Rendering.Video/image capture (#745)")]
			SurfaceLoader.Save(filename, format, backbuffer);

            //[Feature("ScreenCapture")]
            //[Requirement("Rendering.Video/image capture (#745)")]
			backbuffer.Dispose();

			//[Feature("Logging")]
			//[Requirement("Debugging.Logging (#600)")]
			MyTrace.Log(TraceLevel.Info, "Screenshot saved: {0}.", filename);
		}

		/// <summary>
		/// Entry point to the program. Initializes everything and goes into a message processing 
		/// loop. Idle time is used to render the scene.
		/// </summary>
		static public int Main() 
		{
            ////[Feature("Logging")]
            ////[Requirement("Debugging.Logging (#600)")]
            //System.Type forceLoad = typeof(LogFileAspect);

            //[Feature("Logging")]
            //[Requirement("Debugging.Logging (#600)")]
            MyTrace.source = "Goblin";

			//[Feature("Init")]
			Engine sample = new Engine();

            //[Feature("Init")]
            int ret = sample.Run();
            
            //[Feature("Shutdown")]
            //[Requirement("Nonfunctional.Clean shutdown (#1405)")]
            sample.Shutdown();
            
            //[Feature("Shutdown")]
            //[Requirement("Nonfunctional.Clean shutdown (#1405)")]
            sample.Dispose();
            
            //[Feature("Shutdown")]
            //[Requirement("Nonfunctional.Clean shutdown (#1405)")]
            //[Requirement("Debugging.Exception/error detection (#625)")]
            return ret;
		}
	}
}
