///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2005 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Engine/Physics/Collision.cs 49    1/12/07 2:23p Eaddy $
//
//    File name:	CollisionInsurance.cs
//   Created by:	Erik Peterson
//   Created on:	02/25/2005
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Engine/Physics/Collision.cs $
 * 
 * 49    1/12/07 2:23p Eaddy
 * o After annotating all statements with their corresponding requirements
 * 
 * 48    9/29/06 6:18p Eaddy
 * o Annotated program elements with the concern they realize
 * 
 * 47    5/02/06 11:03a Eaddy
 * o Moved MyTrace into separate library
 * 
 * 46    11/11/05 5:47p Eaddy
 * o Fixed problem where the robots were not always coliding with objects
 * 
 * 45    5/30/05 11:51p Eaddy
 * o Fixed bug that was introduced when I added the walls
 * 
 * 44    5/30/05 7:24p Eaddy
 * o No longer logs collisions since they happen so frequently
 * 
 * 43    5/28/05 8:06p Eaddy
 * o Now all trace statements go thru MyTrace for consistency
 * 
 * 42    5/28/05 1:21p Eaddy
 * Changed copyright
 * 
 * 41    5/17/05 10:45p Eaddy
 * o Comments
 * o stopAtFirst should work now
 * 
 * 40    5/17/05 10:08p Eaddy
 * o Added a flag to stop after the first collision although no one is
 * using this
 * 
 * 39    5/17/05 12:19a Eaddy
 * o Optimization?: Now uses blah.LengthSq() instead of Dot(blah, blah)
 * 
 * 38    5/17/05 12:16a Eaddy
 * o Optimization: Reduced number of calls to MyMeshCont which reduces the
 * number
 * of handles that have to be GC'd
 * o Optimization: Cut number of calls to FrameSibling and FirstChild in
 * half
 * 
 * 37    5/16/05 11:29p Eaddy
 * o Optimization: Removed some redundant calls
 * 
 * 36    5/16/05 10:42p Eaddy
 * o Accidentally negated Erik's optimizations
 * 
 * 35    5/16/05 4:13p Eaddy
 * o Cleanup
 * 
 * 34    5/16/05 2:22p Eaddy
 * o Optimization: Eliminated common subexpression
 * 
 * 33    5/16/05 2:20p Eaddy
 * o Optimizations: Removed unused but executed code
 * 
 * 32    5/13/05 7:28p Edp2002
 * FineGrainCD
 * 
 * 31    5/13/05 6:35p Edp2002
 * AABB and BS and NO MESH
 * 
 * 30    5/13/05 4:55p Edp2002
 * 
 * 29    5/13/05 4:45p Edp2002
 * 
 * 28    5/13/05 4:28p Edp2002
 * 
 * 27    5/06/05 4:03p Edp2002
 * eat it
 * 
 * 26    5/06/05 3:01p Edp2002
 * isColliding? no ... ok ... gone
 * 
 * 25    5/06/05 2:54p Edp2002
 * changed damagingNode
 * 
 * 24    4/25/05 6:49p Eaddy
 * o Moved ChaseAITransformer to Engine since it is generic and works for
 * any node
 * (we can chase any node)
 * 
 * 23    4/22/05 9:10p Edp2002
 * check for collision in distance
 * 
 * 22    4/22/05 6:17p Edp2002
 * IsMovingCollision
 * 
 * 21    4/22/05 6:06p Edp2002
 * 
 * 20    4/22/05 3:43p Eaddy
 * o Got rid of framesUntilCollision. You have to use closestHit.Dist and
 * figure the frames out yourself
 * (its more general this way).
 * 
 * 19    4/22/05 3:36p Eaddy
 * o Added OnBeforeCollided
 * 
 * 18    4/21/05 7:22p Edp2002
 * bot_mod.x is the bot that works with collision detection
 * 
 * 17    4/21/05 6:53p Edp2002
 * new media ... target.x, bot.x, crossbow.x, bolt.x
 * 
 * 16    4/20/05 7:57p Edp2002
 * Liger now dies ... 
 * 
 * 15    4/20/05 4:59p Eaddy
 * o Removed assert. It was triggering probably because the difference is
 * below an epsilon
 * value (need to check this).
 * 
 * 14    4/20/05 4:55p Eaddy
 * o Added some asserts
 * o No longer ignores collision with the floor
 * 
 * 13    4/18/05 4:06p Eaddy
 * o Now returns the node we collided with
 * 
 * 12    4/18/05 3:32p Eaddy
 * o Made some changes in anticipation of the new Node/Transformer design
 * (took out Erik's fix
 * for collision detection when the collision distance is very small)
 * 
 * 11    4/18/05 2:03p Eaddy
 * o Trivial opt
 * 
 * 10    4/15/05 3:38p Edp2002
 * slowing down weird effect
 * 
 * 9     4/15/05 3:16p Edp2002
 * new Ghetto Collision detection ... and 2 passes
 * 
 * 8     4/08/05 12:26p Eaddy
 * o Optimizations
 * o Now caches the transformed meshes
 * o Doesn't keep checking after we collided
 * 
 * 7     4/06/05 6:56p Eaddy
 * o Collision detection now works but is slow
 * 
 * 6     4/05/05 5:29p Edp2002
 * i don't know why ... but it works
 * 
 * 5     4/05/05 4:30p Edp2002
 * TransMesh works ... collision ... still looking
 * 
 * 4     4/01/05 8:53p Edp2002
 * still unfinished collision detection
 * 
 * 3     4/01/05 7:32p Edp2002
 * unfinished collision detection changes
 * 
 * 2     2/25/05 7:30p Edp2002
 * Commented out unfinished bussiness
 * 
 * 1     2/25/05 7:22p Edp2002
 * Collision First
 */

using Phx.Aop.Attributes;

using System;
using System.Diagnostics;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using Goblin.Engine.Scene;
using Columbia.Utilities;

namespace Goblin.Engine.Physics
{
	/// <summary>
	/// Summary description for CollisionInsurance.
	/// </summary>
	[Feature("SceneGraph.CollisionDetection")]
	[Requirement("App Development.Collision detection (#1150)")]
	public class Collision
	{
		// This doesn't really work as advertised.  Unless the node is using
		// fine-grained collision detection, we just check if the node's
		// bounding volume is currently intersecting another node's bounding
		// volume.  This check does not provide us with intersection
		// info. If fine-grained CD is used we do get intersection info.
		// stopAtFirstCollision is only useful for fine-grained CD since it
		// allows us to get the closest node.
		public static bool IsCollision( Node node, 
										Bounds boundsNode,
										Vector3[] oldVerts,
										Vector3[] newVerts,
										Node root,
										bool stopAtFirstCollision,
										out Node nodeHit,
										out IntersectInformation closestHit)
		{
			nodeHit = null;
			closestHit = new IntersectInformation();
			closestHit.Dist = float.PositiveInfinity;

			MyMeshContainer meshCont1 = node.MyMeshCont;
			MyMeshContainer meshCont2 = root.MyMeshCont;

			if ( node.Collidable == false ) 
			{
				return false;
			}

			if (root == null || root == node) 
			{
				return false;
			}

			if (meshCont2 != null && 
				root.Collidable)
			{
				bool collision = true;
				IntersectInformation tmp = new IntersectInformation();
				tmp.Dist = float.PositiveInfinity;

				if (meshCont1.FineGrainCD && meshCont2.FineGrainCD)
				{
					collision = DoMeshesIntersect( node, oldVerts, newVerts, root, out tmp) &&
						(closestHit.Dist > tmp.Dist || stopAtFirstCollision);
				}
				else if (meshCont1.FineGrainCD)
				{
					collision = meshCont1.Overlaps(meshCont2.Bounds);
					if (collision)
						tmp.Dist = 10000;
				}
				else if (meshCont2.FineGrainCD)
				{
					collision = meshCont2.Overlaps(boundsNode);
					if (collision)
						tmp.Dist = 10000;
				}
				else
				{
					collision = Bounds.Overlaps(boundsNode, meshCont2.Bounds);
					if (collision)
						tmp.Dist = 10000;
				}

				if (collision)
				{
					nodeHit = root;
					closestHit = tmp;
					//[Requirement("Debugging.Logging (#600)")]
					MyTrace.WriteLine(string.Format("{0}({1})-{2}({3}) Collision", 
						node.Name, 
						meshCont1.FineGrainCD ? "Mesh" : (meshCont1.Bounds.boundingSphere ? "Sphere" : "Box"),
						root.Name,
						meshCont2.FineGrainCD ? "Mesh" : (meshCont2.Bounds.boundingSphere ? "Sphere" : "Box")) );

					if (stopAtFirstCollision)
						return true;
				}
			}

			root = root.FrameFirstChild as Node;
			if ( root != null ) 
			{
				IntersectInformation tmp;
				Node tmpNode;

				if (IsCollision( node, boundsNode, oldVerts, newVerts, root, 
					stopAtFirstCollision, out tmpNode, out tmp) &&
					(closestHit.Dist > tmp.Dist || stopAtFirstCollision)) 
				{
					nodeHit = tmpNode;
					closestHit = tmp;

					if (stopAtFirstCollision)
						return true;
				}

				root = root.FrameSibling as Node;
				while (root != null)
				{
					if (IsCollision( node, boundsNode, oldVerts, newVerts, root, 
						stopAtFirstCollision, out tmpNode, out tmp ) &&
						(closestHit.Dist > tmp.Dist || stopAtFirstCollision)) 
					{
						nodeHit = tmpNode;
						closestHit = tmp;

						if (stopAtFirstCollision)
							return true;
					}

					root = root.FrameSibling as Node;
				}
			}

			return closestHit.Dist != float.PositiveInfinity;
		}

		/*
		public static bool DoMovingSpheresIntersect(Vector3 center1, float radius1, Vector3 vel1, Vector3 center2, float radius2, Vector3 vel2)
		{
			Vector3 dv = vel2-vel1;
			Vector3 dp = center2-center1;
			float r = radius1+radius2;

			float pp = Vector3.Dot(dp,dp)-r*r;
			if ( pp < 0 ) return false;

			float pv = Vector3.Dot(dp,dv);
			if ( pv >= 0 ) return false;

			float vv = Vector3.Dot(dv,dv);
			if ( (pv+vv) <= 0 && (vv+2*pv+pp) >= 0 ) return false;

			float tmin = -pv/vv;

			return ( pp + pv * tmin > 0 );
		}
		*/

		public static bool DoMeshesIntersect(	Node node1,
												Vector3[] oldVerts,
												Vector3[] newVerts, 
												Node node2, 
												out IntersectInformation closestHit)
		{
            //[Requirement("Debugging.Exception/error detection (#625)")]
            //[Requirement("Debugging.Exception/error handling (#630)")]
			Debug.Assert(oldVerts.Length == newVerts.Length);
            //[Requirement("Debugging.Exception/error detection (#625)")]
            //[Requirement("Debugging.Exception/error handling (#630)")]
			Debug.Assert(node1.MyMeshCont != null && node2.MyMeshCont != null);

			// Initialize out params
			closestHit = new IntersectInformation();
			closestHit.Dist = float.PositiveInfinity;

			Mesh mesh2 = node2.MyMeshCont.TransformedMesh;
			if ( mesh2 == null ) return false;

			int closestHitIndex = -1;

			// Create a ray from the old position to the new position.
			// Since the ray is direction only (not magnitude), normalize it.
			//
			// Ideally we would support collision detection for scaling- or
			// rotation-only transformations. Currently, we only support CD for
			// position transformations.  Additional restrictions are that the
			// position change must be a straight line, the rate of change is
			// constant (constant velocity), and that all points are moving in
			// the same direction.
			//
			// Future Opt: Store the normalized vector array of ray directions

			for ( int i = 0; i < oldVerts.Length; ++i )
			{
				Vector3 rayDir = newVerts[i] - oldVerts[i];
				rayDir.Normalize();

				if ( rayDir.Length() == 0 ) 
				{
					continue;
				}

				IntersectInformation curHit;
				if (!mesh2.Intersect(oldVerts[i], rayDir, out curHit) ||
					closestHit.Dist < curHit.Dist)
				{
					continue;
				}

				closestHit = curHit;
				closestHitIndex = i;
			}

			if (closestHit.Dist == float.PositiveInfinity)
			{
				return false; // Didn't collide with this node
			}

            //[Requirement("Debugging.Exception/error detection (#625)")]
            //[Requirement("Debugging.Exception/error handling (#630)")]
			Debug.Assert(closestHitIndex != -1);

			// The closestHit.Dist is the distance from the vertex
			// to the closest face for this mesh.  We have to determine if the
			// node will travel that distance or more in this frame which would
			// indicate a collision with the face.

			// Determine the number of frames it would take for the node traveling at
			// vVelocityFPS to hit the face.  If the number is >=1 then it will take more
			// than one frame so we know there was no collision this frame.  If the number
			// is <1 then we know that a collision would occur sometime between this frame
			// and the next.

			Vector3 diff = newVerts[closestHitIndex] - oldVerts[closestHitIndex];
			return closestHit.Dist < diff.Length();
		}

		public static bool DoSphereRayIntersect(Vector3 center1, float radius1, Vector3 ray, Vector3 dir)
		{
			// sphere eqn t^2(P1*P1)+2t*P1*(P0-C)+(P0-C)*(P0-C)-r^2=0
			Vector3 vecRayCenter1 = ray - center1;

			float A = Vector3.Dot(dir, dir);
			float B = Vector3.Dot(dir, vecRayCenter1) * 2;
			float C = Vector3.Dot(vecRayCenter1, vecRayCenter1) - (radius1*radius1);

			float DISC = B*B - 4*A*C;
	
			if ( DISC < 0 ) 
				return false;

			float param = 0;

			if ( DISC == 0 ) // ONE SOLUTION
			{
//				param = -B/(2*A);
			} 
			else  // TWO SOLUTIONS
			{
				double sqrtDISC = Math.Sqrt(DISC);

				param = (float)((-B + sqrtDISC)/(2.0*A));
				float sol2 = (float)((-B - sqrtDISC)/(2.0*A));
				if(param<0)
				{
					if(sol2<0)
					{
						return false;	//they are both behind us
					}
//					else
//					{
//						param = sol2;		//take the only one that is in front
//					}
				}
//				else
//				{
//					if(sol2<0)
//					{
//						param = param;
//					}
//					else
//					{
//						param = Math.Min(param,sol2);
//					}
//				}
			}

			return true;
		}

		public static bool IsRayColliding(	Node node,
											Vector3 pos,
											Vector3 dir,
											Node root,
											bool stopAtFirstCollision,
											out Node nodeHit,
											out IntersectInformation closestHit)
		{
			// Initialize out params
			nodeHit = null;
			closestHit = new IntersectInformation();
			closestHit.Dist = float.PositiveInfinity;

			if (root == null || root == node) 
			{
				return false;
			}
			else if (root.MeshContainer != null ) 
			{
				Mesh mesh = root.MyMeshCont.TransformedMesh;
				if ( mesh == null ) 
					return false;

				Bounds boundsRoot = root.Bounds;

				IntersectInformation tmp;
				if ( DoSphereRayIntersect(boundsRoot.center, boundsRoot.radius, pos, dir) )
				{
					if ( mesh.Intersect(pos, dir, out tmp) &&
						(closestHit.Dist > tmp.Dist || stopAtFirstCollision))
					{
						closestHit = tmp;
						nodeHit = root;

						if (stopAtFirstCollision)
							return true;
					}
				}
			}

			root = root.FrameFirstChild as Node;
			if ( root != null ) 
			{
				Node tmpNode;
				IntersectInformation tmp;
				if (IsRayColliding( node, pos, dir, root, stopAtFirstCollision, out tmpNode, out tmp) &&
					(closestHit.Dist > tmp.Dist || stopAtFirstCollision))
				{
					nodeHit = tmpNode;
					closestHit = tmp;
					
					if (stopAtFirstCollision)
						return true;
				}

				root = root.FrameSibling as Node;
				while (root != null)
				{
					if (IsRayColliding( node, pos, dir, root, stopAtFirstCollision, out tmpNode, out tmp ) &&
						(closestHit.Dist > tmp.Dist || stopAtFirstCollision)) 
					{
						nodeHit = tmpNode;
						closestHit = tmp;

						if (stopAtFirstCollision)
							return true;
					}

					root = root.FrameSibling as Node;
				}
			}

			return closestHit.Dist != float.PositiveInfinity;
		}
	}
}
