///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2005 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Engine/Scene/Nodes/Node.cs 76    1/22/07 12:13a Eaddy $
//
//    File name:	Node.cs
//   Created by:	Marc Eaddy
//   Created on:	02/02/2005
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Engine/Scene/Nodes/Node.cs $
 * 
 * 76    1/22/07 12:13a Eaddy
 * o Cleaned up some redundant and missing annotations
 * 
 * 75    1/12/07 2:23p Eaddy
 * o After annotating all statements with their corresponding requirements
 * 
 * 74    10/10/06 3:15p Eaddy
 * o Removed redundant concern annotations
 * o We now have 100% concern annotation coverage
 * 
 * 73    9/29/06 6:18p Eaddy
 * o Annotated program elements with the concern they realize
 * 
 * 72    5/02/06 11:03a Eaddy
 * o Moved MyTrace into separate library
 * 
 * 71    6/02/05 9:20p Eaddy
 * o Changed Property to direct member access (makes code cleaner)
 * 
 * 70    5/31/05 6:35p Eaddy
 * o Now when a filter string matches a node it also matches its children
 * o Fixed bug where xbow was being displayed twice (once at the orgin)
 * 
 * 69    5/31/05 5:47p Eaddy
 * o Added ability to filter which nodes are rendered using a string
 * 
 * 68    5/31/05 3:18p Eaddy
 * o Removed unused code
 * 
 * 67    5/31/05 2:59p Eaddy
 * o Consolidated bounding vol and normal rendering
 * 
 * 66    5/28/05 8:06p Eaddy
 * o Now all trace statements go thru MyTrace for consistency
 * 
 * 65    5/28/05 1:21p Eaddy
 * Changed copyright
 * 
 * 64    5/25/05 6:28p Eaddy
 * o Removed unused class
 * 
 * 63    5/17/05 10:45p Eaddy
 * o Added a generic find method
 * 
 * 62    5/17/05 2:51a Eaddy
 * o Removed trace message
 * 
 * 61    5/17/05 12:18a Eaddy
 * o Now uses Bounds class
 * 
 * 60    5/16/05 2:56p Eaddy
 * o Fixed compile error
 * 
 * 59    5/16/05 2:48p Eaddy
 * o Removed unnecessary string creation
 * 
 * 58    5/13/05 4:56p Eaddy
 * o Name isn't needed
 * 
 * 57    5/13/05 3:19p Eaddy
 * o Can now set the mesh container directly (for efficiency)
 * 
 * 56    5/06/05 7:28p Edp2002
 * 
 * 55    5/06/05 4:03p Edp2002
 * 
 * 54    5/06/05 3:01p Edp2002
 * isColliding? no ... ok ... gone
 * 
 * 53    4/25/05 6:04p Eaddy
 * o Converted Set function to set accessor
 * 
 * 52    4/25/05 5:17p Eaddy
 * o Can now toggle whether real objects should be displayed as black (for
 * augmented reality)
 * 
 * 51    4/25/05 4:59p Eaddy
 * o Changed Get methods to get accessors
 * 
 * 50    4/25/05 4:01p Eaddy
 * o Comments
 * o Removed unused parameter
 * o Now accessor handles setting variable recursively
 * 
 * 49    4/22/05 7:53p Edp2002
 * We now have a collidable damagable body for the hero ... a cylinder
 * 
 * 48    4/22/05 6:05p Edp2002
 * no more if "GEOM" garbage
 * 
 * 47    4/22/05 3:44p Eaddy
 * o Removed unused method
 * 
 * 46    4/22/05 3:43p Eaddy
 * o Got rid of framesUntilCollision. You have to use closestHit.Dist and
 * figure the frames out yourself
 * (its more general this way).
 * 
 * 45    4/22/05 3:36p Eaddy
 * o Added OnBeforeCollided
 * 
 * 44    4/21/05 7:49p Edp2002
 * LIGERHUNTER!
 * 
 * 43    4/21/05 6:53p Edp2002
 * new media ... target.x, bot.x, crossbow.x, bolt.x
 * 
 * 42    4/20/05 7:57p Edp2002
 * Liger now dies ... 
 * 
 * 41    4/20/05 6:06p Edp2002
 * DamagableNode
 * 
 * 40    4/20/05 5:30p Eaddy
 * o Removed controllers. Now uses Transformer exclusively.
 * 
 * 39    4/20/05 4:53p Eaddy
 * o Need to update the mesh container mesh vertices for now
 * 
 * 38    4/20/05 3:37p Eaddy
 * o Almost working
 * 
 * 37    4/18/05 4:38p Eaddy
 * o Added Transformer. Doesn't work yet.
 * 
 * 36    4/18/05 4:06p Eaddy
 * o Now returns the node we collided with
 * 
 * 35    4/18/05 3:32p Eaddy
 * o Made some changes in anticipation of the new Node/Transformer design
 * (took out Erik's fix
 * for collision detection when the collision distance is very small)
 * 
 * 34    4/15/05 3:23p Eaddy
 * o Added ability to add meshes to scene graph
 * 
 * 33    4/15/05 3:16p Edp2002
 * new Ghetto Collision detection ... and 2 passes
 * 
 * 32    4/08/05 4:33p Eaddy
 * o Comments
 * 
 * 31    4/08/05 12:28p Eaddy
 * o Now uses Geometry.ComputeBoundingSphere and also moved code into
 * MyMeshContainer
 * 
 * 30    4/06/05 7:02p Eaddy
 * o You should now call Dispose() when done with a node
 * o Now keeps the mesh container's transformed mesh up-to-date
 * 
 * 29    4/05/05 4:30p Edp2002
 * TransMesh works ... collision ... still looking
 * 
 * 28    4/01/05 9:05p Edp2002
 * still still unfinished collision detection
 * 
 * 27    4/01/05 8:53p Edp2002
 * still unfinished collision detection
 * 
 * 26    4/01/05 7:32p Edp2002
 * unfinished collision detection changes
 * 
 * 25    3/23/05 10:56p Eaddy
 * o More BSP work
 * 
 * 24    3/22/05 2:02p Eaddy
 * o Fixed bug where the second time we called DrawSubset on a mesh we got
 * an D3DERR_INVALIDCALL exception. It was caused by not unlocking the
 * vertex
 * buffer.
 * 
 * 23    2/25/05 9:22p Eaddy
 * o Added some commented code for testing BSP trees
 * 
 * 22    2/25/05 7:22p Edp2002
 * GetCollisionSphere
 * 
 * 21    2/22/05 11:33p Eaddy
 * o Added Node.SetController() method
 * 
 * 20    2/22/05 11:25p Eaddy
 * o Now uses lightweight C# delegates instead of Java-style interfaces
 * o CombineTransformations and Render now traverse every node
 * 
 * 19    2/18/05 9:59p Eaddy
 * o Created a generic 6DOF transformer class that supports 6DOF data from
 * a DX camera or an IS900 tracker
 * 
 * 18    2/18/05 8:55p Eaddy
 * o Made Render virtual so CameraNode could override it
 * 
 * 17    2/18/05 8:33p Eaddy
 * o Renamed MyFrame to Node for clarity
 * 
 * 16    2/18/05 7:55p Eaddy
 * o Made method names consistent by starting them with uppercase
 * 
 * 15    2/18/05 7:47p Eaddy
 * o Moved rendering code into MyFrame and MyMeshContainer
 * 
 * 14    2/18/05 7:35p Eaddy
 * o Now is able to find media in the Media directory and named
 * subdirectories (Tiger)
 * 
 * 13    2/18/05 3:32p Edp2002
 * o Fixed transformation bug that caused all models to explode
 * 
 * 12    2/18/05 3:01p Edp2002
 * fix
 * 
 * 11    2/18/05 2:34p Edp2002
 * fix animation ... marc! GOD! 
 * 
 * 10    2/18/05 2:37p Eaddy
 * o Moved code into MyFrame
 * 
 * 9     2/18/05 1:59p Eaddy
 * o Moved addMesh() to MyFrame
 * o Made Animate an official property
 * 
 * 8     2/04/05 5:12p Edp2002
 * Added animation functions and flag
 * 
 * 7     2/04/05 3:35p Edp2002
 * come correct mark ... gave you a constructor
 * 
 * 6     2/02/05 4:56p Eaddy
 * o Added VSS comment header
 */

using Phx.Aop.Attributes;

using System;
using System.IO;
using System.Diagnostics;
using System.Collections;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

//using ExoEngine.Geometry;

using Columbia.Utilities;

using Goblin.Engine.Devices;
using Goblin.Engine.Utilities;
using Goblin.Engine.Physics;

namespace Goblin.Engine.Scene
{
	/// <summary>
	/// The frame that will hold mesh animation 
	/// </summary>
    [Feature("SceneGraph")]
    [Requirement("Rendering.Scene graph (#735)")]
    [Requirement("App Development.Object model (#1110)")]
    [Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
	public class Node : Frame, IDisposable
	{
		// DATA

		/// <summary>
		/// The combined transformation matrix
		/// </summary>
		[Feature("SceneGraph")]
		[Requirement("Rendering.Scene graph (#735)")]
		private Matrix combined = Matrix.Identity;

		[Feature("SceneGraph")]
		[Requirement("Rendering.Scene graph (#735)")]
		private Matrix velocity = Matrix.Identity;

		/// <summary>
		/// Transformer that moves the node 
		/// </summary>
		[Feature("SceneGraph")]
		[Requirement("Rendering.Scene graph (#735)")]
		private Transformer transformer;

		/// <summary>
		/// Will this branch be animated 
		/// </summary>
		[Feature("SceneGraph")]
		[Requirement("Rendering.Scene graph (#735)")]
		private bool animated = false;

		/// <summary>
		/// Should we check for collision 
		/// </summary>
		[Requirement("App Development.Collision detection (#1150)")]
		private bool collidable = true;

		/// <summary>
		/// Should we check for collision 
		/// </summary>
		[Feature("SceneGraph")]
		[Requirement("Rendering.Scene graph (#735)")]
		private bool renderable = true;

		/// <summary>
		/// Has the object moved since it last collided
		/// </summary>
		[Requirement("Operational.Minimum frame rate of 15 fps (#1305)")]
		[Requirement("Operational.Maximum user input latency of 1 second (#1310)")]
		[Requirement("Operational.Target frame rate of 60 fps (#1300)")]
		private bool moved = true;

		/// <summary>
		/// Is the object a real physical object in the world
		/// or a virtual object
		/// </summary>
		[Feature("SceneGraph")]
		[Requirement("3D UI.Real-world object occlusion (#935)")]
		private bool isReal = false;

		/// <summary>
		/// Whether to render real objects as black
		/// </summary>
		/// <remarks>
		/// Needed when displaying in Augmented Reality.  Real objects
		/// should be rendered black so that they occlude virtual objects
		/// and so they appear transparent in the AR display.
		/// </remarks>
		[Feature("GUI.AR")]
		[Requirement("3D UI.Real-world object occlusion (#935)")]
		[Requirement("Debugging.Application visualization (#620)")]
		private bool renderRealAsBlack = false;

		// CTOR

		[Requirement("Rendering.Scene graph (#735)")]
		public Node(string name) 
		{
			//[Requirement("App Development.Object model (#1110)")]
			this.Name = name;
			this.TransformationMatrix = Matrix.Identity;
		}

		[Requirement("Nonfunctional.Clean shutdown (#1405)")]
		public void Dispose()
		{
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (MyMeshCont != null)
				//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
				MyMeshCont.Dispose();

			Node firstChild = (Node) FrameFirstChild;
			if (firstChild != null)
			{
				firstChild.Dispose();

				Node sibling = (Node) firstChild.FrameSibling;
				while ( sibling != null ) 
				{
					sibling.Dispose();
					sibling = (Node) sibling.FrameSibling;
				}
			}
		}

		// ACCESSORS

		/// <summary>
		/// Contains the mesh for the node if it has one
		/// </summary>
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("App Development.Object model (#1110)")]
		public MyMeshContainer MyMeshCont
		{
			get { return MeshContainer as MyMeshContainer; }
			set { MeshContainer = value; }
		}

		[Requirement("App Development.Collision detection (#1150)")]
		[Requirement("Debugging.Application visualization (#620)")]
		[Requirement("App Development.Object model (#1110)")]
		public Bounds Bounds
		{
			get
			{
				MyMeshContainer meshCont = MyMeshCont;
				//[Requirement("Debugging.Exception/error detection (#625)")]
				if (meshCont == null)
					//[Requirement("Debugging.Exception/error handling (#630)")]
					return null;
				else
					return meshCont.Bounds;
			}
		}

		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("App Development.Object model (#1110)")]
		public Matrix CombinedTransformationMatrix
		{
			get { return combined; } 
			set { combined = value; }
		}

		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("Rendering.Multiple coordinate systems (#705)")]
		[Requirement("Rendering.Relative coordinate systems (#710)")]
		[Requirement("App Development.Object model (#1110)")]
		public Vector3 getPosition()
		{
			return MyUtility.MatrixGetTranslation(combined);
		}

		/// <summary>
		/// Is the node moving?
		/// </summary>
		[Requirement("App Development.Object model (#1110)")]
		[Requirement("Rendering.Scene graph (#735)")]
		public bool Animated
		{
			get { return animated; }
			set 
			{ 
				animated = value; 

				Node firstChild = (Node) FrameFirstChild;
				if (firstChild != null)
				{
					firstChild.Animated = value;

					Node sibling = (Node) firstChild.FrameSibling;
					while ( sibling != null ) 
					{
						sibling.Animated = value;
						sibling = (Node) sibling.FrameSibling;
					}
				}
			}
		}

		/// <summary>
		/// check for collisions
		/// </summary>
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("App Development.Collision detection (#1150)")]
		[Requirement("App Development.Object model (#1110)")]
		public bool Collidable
		{
			get { return collidable; }
			set 
			{ 
				collidable = value; 

				Node firstChild = (Node) FrameFirstChild;
				if (firstChild != null)
				{
					firstChild.Collidable = value;

					Node sibling = (Node) firstChild.FrameSibling;
					while ( sibling != null ) 
					{
						sibling.Collidable = value;
						sibling = (Node) sibling.FrameSibling;
					}
				}
			}
		}

		/// <summary>
		/// check for render
		/// </summary>
		[Requirement("App Development.Object model (#1110)")]
		[Requirement("Rendering.Scene graph (#735)")]
		public bool Renderable
		{
			get { return renderable; }
			set { renderable = value; }
		}

		[Feature("GUI.AR")]
		[Requirement("App Development.Object model (#1110)")]
		[Requirement("3D UI.Real-world object occlusion (#935)")]
		[Requirement("Rendering.Scene graph (#735)")]
		public bool IsReal
		{                                                                   
			get { return isReal; }                                          
			set                                                             
			{                                                               
				isReal = value;                                             

				MyMeshContainer mesh = MeshContainer as MyMeshContainer;    
				while(mesh != null)                                         
				{                                                           
					//[Requirement("App Development.Object model (#1110)")]
					//[Requirement("3D UI.Real-world object occlusion (#935)")]
					//[Requirement("Rendering.Scene graph (#735)")]
					//[Requirement("Debugging.Application visualization (#620)")]
					mesh.RenderAsBlack = isReal && renderRealAsBlack;       
					mesh = mesh.NextContainer as MyMeshContainer;           
				}                                                           

				Node firstChild = (Node) FrameFirstChild;                   
				if (firstChild != null)                                     
				{                                                           
					firstChild.IsReal = value;                              

					Node sibling = (Node) firstChild.FrameSibling;          
					while ( sibling != null )                               
					{                                                       
						sibling.IsReal = value;                             
						sibling = (Node) sibling.FrameSibling;              
					}                                                       
				}                                                           
			}                                                               
		}                                                                   

		[Feature("GUI.AR")]
		[Requirement("App Development.Object model (#1110)")]
		[Requirement("3D UI.Real-world object occlusion (#935)")]
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("Debugging.Application visualization (#620)")]
		public bool RenderRealAsBlack
		{                                                                   
			get                                                             
			{                                                               
				return renderRealAsBlack;                                   
			}                                                               
			set                                                             
			{                                                               
				renderRealAsBlack = value;                                  

				MyMeshContainer mesh = MeshContainer as MyMeshContainer;    
				while(mesh != null)                                         
				{                                                           
					mesh.RenderAsBlack = isReal && renderRealAsBlack;       
					mesh = mesh.NextContainer as MyMeshContainer;           
				}                                                           
                                                                            
				Node firstChild = (Node) FrameFirstChild;                   
				if (firstChild != null)                                     
				{                                                           
					firstChild.RenderRealAsBlack = value;                   
                                                                            
					Node sibling = (Node) firstChild.FrameSibling;          
					while ( sibling != null )                               
					{                                                       
						sibling.RenderRealAsBlack = value;                  
						sibling = (Node) sibling.FrameSibling;              
					}                                                       
				}                                                           
			}                                                               
		}                                                                   

		/// <summary>
		/// Has the node moved since it last collided with something?
		/// </summary>
		[Feature("Opt")]
		[Requirement("Operational.Minimum frame rate of 15 fps (#1305)")]
		[Requirement("Operational.Maximum user input latency of 1 second (#1310)")]
		[Requirement("Operational.Target frame rate of 60 fps (#1300)")]
		[Requirement("App Development.Object model (#1110)")]
		public bool HasMoved
		{                                                                   
			get { return moved; }                                           
		}                                                                   

		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("App Development.Object model (#1110)")]
		public Transformer Transformer
		{                                                                   
			get { return transformer; }                                     
			set                                                             
			{                                                               
				this.transformer = value;                                   

				if (value != null)                                          
					this.Animated = true;                                   
			}                                                               
		}                                                                   

		// METHODS

		[Requirement("Rendering.Dynamic scene geometry (#740)")]
		[Requirement("Rendering.Scene graph (#735)")]
		public Frame AppendChild(Frame child)
		{                                                                   
			Frame.AppendChild(this, child);                                 
			return child;                                                   
		}                                                                   
                                                                            
		[Requirement("Rendering.Dynamic scene geometry (#740)")]
		[Requirement("Rendering.Scene graph (#735)")]
		public Node AppendChild(Node child)
		{                                                                   
			Frame.AppendChild(this, child);                                 
			return child;                                                   
		}                                                                   
                                                                            
		[Feature("Persistence.Loading")]
		[Requirement("Rendering.Dynamic scene geometry (#740)")]
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("Configuration.Import - DirectX (#720)")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		public Node AddXFile(Device device, string fileName, XFileManager xfileMgr )
		{                                                                               
			string path = MyUtility.MyFindMediaFile(fileName);                          
			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (path == null)
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return null;

			XFile xfile = xfileMgr.FromFile(path);                                      
			//[Feature("EC")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (xfile == null)
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return null;

			// Convert from 3DS coor system to Lab coordinate system
			//[Requirement("Rendering.Coordinate system independence (#715)")]
			{
				Matrix mat3DS2Lab = Matrix.RotationY(Geometry.DegreeToRadian(180));         
				//MyTrace.Write(Matrix2String(mat3DS2Lab, "mat3DS2Lab"));
	
				// Convert from Lab coor system to DirectX coor system
				Matrix matLab2DX = Matrix.Scaling(1, 1, -1) *                               
					Matrix.RotationX(Geometry.DegreeToRadian(-90)) *                        
					Matrix.RotationY(Geometry.DegreeToRadian(180));                         
				//	MyTrace.Write(Matrix2String(matLab2DX, "matLab2DX"));
	
				// Convert from 3DS coor system to DirectX coor system
				//[Requirement("Nonfunctional.Unused (#1400)")]
				Matrix mat3DS2DX = Matrix.Scaling(1, 1, -1) * Matrix.RotationX(Geometry.DegreeToRadian(90));
				//	MyTrace.Write(Matrix2String(mat3DS2DX, "mat3DS2DX"));
	
				TransformationMatrix = mat3DS2Lab * matLab2DX;

				//[Feature("Logging")]
				//[Requirement("Debugging.Logging (#600)")]
				MyTrace.Write(this.ToString("TransformationMatrix"));
			}

			//[Feature("Logging")]
			//[Requirement("Debugging.Logging (#600)")]
			MyTrace.WriteLine("xfile: " + fileName + " Children: " + xfile.NumberChildren);
			for(int i = 0; i < xfile.NumberChildren; ++i)                               
			{                                                                           
				using (XFileData xfileData = xfile.GetChild(i))                         
				{                                                                       
					AddXFileData(device, Path.GetDirectoryName(fileName), xfileData, "");
				}                                                                       
			}                                                                           

			//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
			xfile.Dispose();                                                            
			//[Requirement("Debugging.Exception/error detection (#625)")]
			xfile = null;                                                               

			//[Requirement("Debugging.Exception/error handling (#630)")]
			return this;                                                                
		}                                                                               

		[Feature("Persistence.Loading")]
		[Requirement("Rendering.Dynamic scene geometry (#740)")]
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("Configuration.Import - DirectX (#720)")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		public void AddXFileData(	Device device,
									string directory,                                   
									XFileData xfileData,                                
									[Requirement("Debugging.Logging (#600)")] string indent)                                      
		{                                                                               
			#if false                                                                   
			//[Feature("Logging")]
			//[Requirement("Debugging.Logging (#600)")]
			Trace.WriteLine(indent + MyUtility.XFileGuid2Str(xfileData.Type) +
				": " + xfileData.Name);                                                 
			#endif                                                                      

			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (xfileData.Type == XFileGuid.Material ||
				xfileData.Type == XFileGuid.AnimationSet ||                             
				xfileData.Type == XFileGuid.Animation ||                                
				xfileData.Type == XFileGuid.AnimationKey)                               
			{                                                                           
				//[Feature("Logging")]
				//[Requirement("Debugging.Logging (#600)")]
				//[Requirement("Debugging.Exception/error handling (#630)")]
				MyTrace.WriteLine(indent + "Ignoring xfile node: " +
					MyUtility.XFileGuid2Str(xfileData.Type) + ": " + xfileData.Name);
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return;                                                                 
			}                                                                           
			else if (xfileData.Type == XFileGuid.FrameTransformMatrix)                  
			{                                                                           
				SetTransformationMatrix(xfileData);                                     
			}                                                                           
			else if (xfileData.Type == XFileGuid.Mesh)                                  
			{                                                                           
				//[Feature("EC")]
	            //[Requirement("Debugging.Exception/error detection (#625)")]
    	        //[Requirement("Debugging.Exception/error handling (#630)")]
				Debug.Assert(MeshContainer == null);
				MeshContainer = new MyMeshContainer();                                  
				((MyMeshContainer) MeshContainer).Init(device, directory, xfileData, indent);
			}                                                                           
			//:block[Requirement("Debugging.Exception/error detection (#625)")]
			else if (	xfileData.Type == XFileGuid.Frame ||                            
						xfileData.NumberChildren > 0)                                   
			{           
				//[Requirement("Rendering.Dynamic scene geometry (#740)")]
				//[Requirement("Rendering.Scene graph (#735)")]
				//[Requirement("Configuration.Import - DirectX (#720)")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				{
					Node childNode = new Node(xfileData.Name);                              
	
					AppendChild(childNode);                                                 
	
					//[Feature("Logging")]
					//[Requirement("Debugging.Logging (#600)")]
					string strChildIndent = indent + "  ";
	
					for(int j = 0; j < xfileData.NumberChildren; ++j)                       
					{                                                                       
						using (XFileData xfileDataChild = xfileData.GetChild(j))            
						{                                                                   
							childNode.AddXFileData(device, directory, xfileDataChild,       
								strChildIndent);                                            
						}                                                                   
					}                                                                       
				}
			}                                                                           
			else                                                                        
			{                                                                           
				//[Feature("Logging")]
				//[Requirement("Debugging.Logging (#600)")]
				MyTrace.WriteLine(indent + "Ignoring xfile node: " +
					MyUtility.XFileGuid2Str(xfileData.Type) + ": " + xfileData.Name);   
			}                                                                           
		}

		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("Configuration.Import - DirectX (#720)")]
		public void SetMesh(	Device device,
								string directory,                                       
								Mesh mesh,                                              
								GraphicsStream adjacency,                               
								ExtendedMaterial[] materials,                           
								[Requirement("Debugging.Logging (#600)")] string indent)                                          
		{                                                                               
			//[Feature("EC")]
            //[Requirement("Debugging.Exception/error detection (#625)")]
            //[Requirement("Debugging.Exception/error handling (#630)")]
			Debug.Assert(MeshContainer == null);
			MeshContainer = new MyMeshContainer();                                      
			((MyMeshContainer) MeshContainer).Init(device, Name, directory, mesh, adjacency, materials, indent);
		}                                                                               

		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("Configuration.Import - DirectX (#720)")]
		private void SetTransformationMatrix(XFileData xfileData)
		{                                                                               
			GraphicsStream gs = xfileData.Lock();                                       
		
			TransformationMatrix = (Matrix) gs.Read(typeof(Matrix));                    

			//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
			{
				gs.Dispose();                                                               
				xfileData.Unlock();
			}
		}

		/// <summary>
		/// Updates the combined transformation using the transformer
		/// </summary>
		/// <param name="device"></param>
		/// <param name="parentMatrix"></param>
		/// <param name="elapsedTime"></param>
		/// <returns></returns>
		[Requirement("Rendering.Scene graph (#735)")]
		public bool SetCombinedTransformations(Node root, Device device, Matrix parentMatrix, float elapsedTime)
		{                                                                       
			Matrix oldCombined = combined;                                      

			if (transformer != null)                                            
			{                                                                   
				transformer.FrameMove(this, root, elapsedTime);                 
				Matrix tmp = transformer.current.Combine();                     
				//[Requirement("Operational.Minimum frame rate of 15 fps (#1305)")]
				//[Requirement("Operational.Maximum user input latency of 1 second (#1310)")]
				//[Requirement("Operational.Target frame rate of 60 fps (#1300)")]
				if ( parentMatrix != Matrix.Identity )                          
					combined = tmp * parentMatrix;                              
				else                                                            
					combined = tmp;                                             
			}                                                                   
			else                                                                
			{                                                                   
				combined = TransformationMatrix * parentMatrix;                 
			}                                                                   
                                                                                
			//[Feature("Opt")]
			//[Requirement("Operational.Minimum frame rate of 15 fps (#1305)")]
			//[Requirement("Operational.Maximum user input latency of 1 second (#1310)")]
			//[Requirement("Operational.Target frame rate of 60 fps (#1300)")]
			moved = oldCombined != combined;

			//[Feature("Opt")]
			//[Feature("EC")]
			//[Requirement("Operational.Minimum frame rate of 15 fps (#1305)")]
			//[Requirement("Operational.Maximum user input latency of 1 second (#1310)")]
			//[Requirement("Operational.Target frame rate of 60 fps (#1300)")]
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (moved && MyMeshCont != null)
			{                                                                   
				// Update the transformed meshes                                
				//[Feature("Opt")]
				//[Feature("SceneGraph")]
				//[Requirement("Rendering.Scene graph (#735)")]
				MyMeshCont.FrameMove(device, combined);
			}                                                                   
                                                                                
			return moved;                                                       
		}                                                                       
                                                                                
		[Requirement("Rendering.Scene graph (#735)")]
		public void CombineTransformations(Node root, Device device, Matrix parentMatrix)
		{                                                                                 
			SetCombinedTransformations(root, device, parentMatrix, 0);                    

			MyMeshContainer mesh = MeshContainer as MyMeshContainer;            
			while(mesh != null)                                                 
			{                                                                   
				mesh.FrameMove(device, combined);                               
				mesh = mesh.NextContainer as MyMeshContainer;                   
			}                                                                   

			Node firstChild = (Node) FrameFirstChild;                           
			if (firstChild != null)                                             
			{                                                                   
				firstChild.CombineTransformations(root, device, combined);      
                                                                                
				Node sibling = (Node) firstChild.FrameSibling;                  
				while ( sibling != null )                                       
				{                                                               
					sibling.CombineTransformations(root, device, combined);     
					sibling = (Node) sibling.FrameSibling;                      
				}                                                               
			}                                                                   
		}                                                                       
                                                                                
		[Requirement("Rendering.Scene graph (#735)")]
		public void FrameMove(Node root, Device device, float elapsedTime)
		{                                                                       
			FrameMove(root, device, Matrix.Identity, elapsedTime );             
		}                                                                       
                                                                                
		[Requirement("App Development.Object model (#1110)")]
		[Requirement("Rendering.Scene graph (#735)")]
		public Node findFirst(string pattern)
		{                                                                       
			return findHelper(pattern, null, true);                             
		}                                                                       

		[Requirement("App Development.Object model (#1110)")]
		[Requirement("Rendering.Scene graph (#735)")]
		public void find(string pattern, ArrayList matches)
		{                                                                       
			findHelper(pattern, matches, false);                                
		}                                                                       

		[Requirement("App Development.Object model (#1110)")]
		[Requirement("Rendering.Scene graph (#735)")]
		private Node findHelper(string pattern, ArrayList matches, bool stopAfterFirst)
		{                                                                       
			// Either pass in a matches array or specify stopAfterFirst
			//[Feature("EC")]
            //[Requirement("Debugging.Exception/error detection (#625)")]
            //[Requirement("Debugging.Exception/error handling (#630)")]
			Debug.Assert(stopAfterFirst || matches != null);

			if (pattern == null || Name.IndexOf(pattern) != -1)                 
			{                                                                   
				if (stopAfterFirst)                                             
					return this;                                                
				else                                                            
					matches.Add(this);                                          
			}                                                                   
                                                                                
			Node firstChild = (Node) FrameFirstChild;                           
			if (firstChild != null)                                             
			{                                                                   
				Node found = firstChild.findHelper(pattern, matches, stopAfterFirst); 
				if (found != null)                                              
					return found;                                               
                                                                                
				Node sibling = (Node) firstChild.FrameSibling;                  
				while ( sibling != null )                                       
				{                                                               
					found = sibling.findHelper(pattern, matches, stopAfterFirst); 
					if (found != null)                                          
						return found;                                           
					sibling = (Node) sibling.FrameSibling;                      
				}                                                               
			}                                                                   
                                                                                
			return null;                                                        
		}                                                                       
                                                                                
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("App Development.Collision detection (#1150)")]
		public void setCollidable(bool collision, string pattern)
		{                                                                       
			ArrayList matches = new ArrayList();                                
			find(pattern, matches);                                             
                                                                                
			for(int i = 0; i < matches.Count; ++i)                              
			{                                                                   
				Node node = (Node) matches[i];                                  
				node.Collidable = collision;                                    
			}                                                                   
		}                                                                       
                                                                                
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("App Development.Collision detection (#1150)")]
		public void setAllCollidable(bool collision)
		{                                                                       
			ArrayList matches = new ArrayList();                                
			find(null, matches);                                                
                                                                                
			for(int i = 0; i < matches.Count; ++i)                              
			{                                                                   
				Node node = (Node) matches[i];                                  
				node.Collidable = collision;                                    
			}                                                                   
		}                                                                       
                                                                                
		[Requirement("Rendering.Scene graph (#735)")]
		public void setRenderable(bool render, string pattern)
		{                                                                       
			ArrayList matches = new ArrayList();                                
			find(pattern, matches);                                             
                                                                                
			for(int i = 0; i < matches.Count; ++i)                              
			{                                                                   
				Node node = (Node) matches[i];                                  
				node.Renderable = render;                                       
			}                                                                   
		}                                                                       
                                                                                
		[Requirement("Rendering.Scene graph (#735)")]
		public void setAllRenderable(bool render)
		{                                                                       
			ArrayList matches = new ArrayList();                                
			find(null, matches);                                                
                                                                                
			for(int i = 0; i < matches.Count; ++i)                              
			{                                                                   
				Node node = (Node) matches[i];                                  
				node.Renderable = render;                                       
			}                                                                   
		}                                                                       
                                                                                
		[Requirement("Rendering.Scene graph (#735)")]
		public virtual void FrameMove(Node root, Device device, Matrix parentMatrix, float elapsedTime)
		{                                                                               
			if (Animated)                                                               
			{                                                                           
				SetCombinedTransformations(root, device, parentMatrix, elapsedTime);    
			}                                                                           
                                                                                        
			Node firstChild = (Node) FrameFirstChild;                                   
			if (firstChild != null)                                                     
			{                                                                           
				firstChild.FrameMove(root, device, combined, elapsedTime);              
                                                                                        
				Node sibling = (Node) firstChild.FrameSibling;                          
				while ( sibling != null )                                               
				{                                                                       
					sibling.FrameMove(root, device, parentMatrix, elapsedTime);         
					sibling = (Node) sibling.FrameSibling;                              
				}                                                                       
			}                                                                           
		}                                                                               
                                                                                        
		/// <summary>Draw a frame and all child and sibling frames</summary>            
		[Feature("GUI")]
		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		public virtual void Render(Device device, string filter, int pass)
		{                                                                               
			if (filter != null && Name.IndexOf(filter) != -1)                           
			{                                                                           
				// Force all the children to draw                                       
				filter = null;                                                          
			}                                                                           
                                                                                        
			if (pass == SceneGraph.GEOMETRY_PASS ||                                     
				pass == SceneGraph.BOUNDING_VOLUME_PASS)                                
			{                                                                           
				// Set up transforms.  The transform for a child frame is the           
				// combination of the transforms of its parents.
				if (pass == SceneGraph.GEOMETRY_PASS)                                   
				{                                                                       
					device.Transform.World = CombinedTransformationMatrix;              
				}                                                                       
                                                                                        
				MyMeshContainer mesh = MeshContainer as MyMeshContainer;                
				while(mesh != null)                                                     
				{                                                                       
					if (renderable && filter == null)                                   
					{                                                                   
						if (pass == SceneGraph.GEOMETRY_PASS)                           
						{                                                               
							mesh.Render(device);                                        
						}                                                               
						else if (pass == SceneGraph.BOUNDING_VOLUME_PASS)               
						{                                                               
							mesh.RenderBoundingVolume(device);                          
						}                                                               
					}                                                                   
                                                                                        
					mesh = mesh.NextContainer as MyMeshContainer;                       
				}                                                                       
			}                                                                           
                                                                                        
			Node firstChild = (Node) FrameFirstChild;                                   
			if (firstChild != null)                                                     
			{                                                                           
				firstChild.Render(device, filter, pass);                                
                                                                                        
				Node sibling = (Node) firstChild.FrameSibling;                          
				while ( sibling != null )                                               
				{                                                                       
					sibling.Render(device, filter, pass);                               
					sibling = (Node) sibling.FrameSibling;                              
				}                                                                       
			}                                                                           
		}                                                                               
		
		/// <summary>Update the frames matrices and combine it with it's parents</summary>
		[Feature("Diagnostics")]
		public override string ToString()
		{                                                                               
			return ToString("<NONE>");                                                  
		}                                                                               

		[Feature("Diagnostics")]
		[Requirement("Debugging.Logging (#600)")]
		public string ToString(string name)
		{                                                                               
			return MyUtility.MatrixToString(TransformationMatrix, name);                
		}                                                                               
	}
}
