///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2005 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Engine/Scene/SceneGraph.cs 56    1/22/07 12:13a Eaddy $
//
//    File name:	SceneGraph.cs
//   Created by:	Marc Eaddy
//   Created on:	02/02/2005
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Engine/Scene/SceneGraph.cs $
 * 
 * 56    1/22/07 12:13a Eaddy
 * o Cleaned up some redundant and missing annotations
 * 
 * 55    1/12/07 2:23p Eaddy
 * o After annotating all statements with their corresponding requirements
 * 
 * 54    9/29/06 6:18p Eaddy
 * o Annotated program elements with the concern they realize
 * 
 * 53    5/02/06 11:03a Eaddy
 * o Moved MyTrace into separate library
 * 
 * 52    5/31/05 5:48p Eaddy
 * o Comment
 * 
 * 51    5/31/05 5:46p Eaddy
 * o Added ability to filter which nodes are rendered using a string
 * 
 * 50    5/31/05 3:38p Eaddy
 * o Comment
 * 
 * 49    5/31/05 3:37p Eaddy
 * o Fixed bug where BVs were rendered solid
 * 
 * 48    5/31/05 2:57p Eaddy
 * o Removed last of BSP code
 * o Added a pass for rendering the bounding vols
 * 
 * 47    5/28/05 1:21p Eaddy
 * Changed copyright
 * 
 * 46    5/25/05 6:32p Eaddy
 * o Removed BSP stuff
 * 
 * 45    5/13/05 4:56p Eaddy
 * o Name isn't needed
 * 
 * 44    4/25/05 4:59p Eaddy
 * o Changed Get methods to get accessors
 * 
 * 43    4/25/05 4:02p Eaddy
 * o Trivial changes
 * 
 * 42    4/20/05 7:57p Edp2002
 * Liger now dies ... 
 * 
 * 41    4/20/05 6:07p Edp2002
 * SKIP_PASS added
 * 
 * 40    4/20/05 6:05p Edp2002
 * CAMERA_PASS added
 * 
 * 39    4/15/05 6:27p Eaddy
 * o Added ability to add meshes to scene graph
 * 
 * 37    4/15/05 3:16p Edp2002
 * new Ghetto Collision detection ... and 2 passes
 * 
 * 36    4/06/05 7:00p Eaddy
 * o Minor method changes
 * 
 * 35    4/05/05 6:39p Eaddy
 * o Moved code into helper class
 * 
 * 34    4/01/05 7:32p Edp2002
 * unfinished collision detection changes
 * 
 * 33    4/01/05 3:38p Eaddy
 * o Commented BSP code
 * 
 * 32    3/28/05 12:02p Eaddy
 * 
 * 31    3/23/05 10:56p Eaddy
 * o More BSP work
 * 
 * 30    3/22/05 2:03p Eaddy
 * o App no longer halts if file isn't found
 * 
 * 29    2/25/05 4:11p Edp2002
 * GetRootNode()
 * 
 * 28    2/22/05 11:26p Eaddy
 * o Now sets the name for added nodes
 * o Renamed Animate() to FrameMove() so its consistent with DX
 * terminology
 * 
 * 27    2/18/05 8:54p Eaddy
 * o Changed addEmptyNode to addNode (more generic)
 * 
 * 26    2/18/05 8:33p Eaddy
 * o Renamed MyFrame to Node for clarity
 * 
 * 25    2/18/05 7:55p Eaddy
 * o Made method names consistent by starting them with uppercase
 * 
 * 24    2/18/05 7:47p Eaddy
 * o Moved rendering code into MyFrame and MyMeshContainer
 * 
 * 23    2/18/05 7:35p Eaddy
 * o Now is able to find media in the Media directory and named
 * subdirectories (Tiger)
 * 
 * 22    2/18/05 7:11p Edp2002
 * addCamera renamed addEmptyNode
 * 
 * 21    2/18/05 7:07p Edp2002
 * camera added as node in scene graph
 * 
 * 20    2/18/05 2:37p Eaddy
 * o Moved code into MyFrame
 * 
 * 19    2/18/05 1:59p Eaddy
 * o Moved addMesh() to MyFrame
 * o Made Animate an official property
 * 
 * 18    2/18/05 1:08p Jrw2005
 * 
 * 17    2/17/05 3:37p Eaddy
 * o Bug fix: No longer displays bounding boxes
 * 
 * 16    2/11/05 9:50p Eaddy
 * o Now looks in some obvious places to find media files
 * 
 * 15    2/11/05 1:14p Eaddy
 * o Now converts from 3DS to Lab to DX
 * 
 * 14    2/10/05 4:22p Eaddy
 * o Now loads all meshes including bounding boxes.  Bounding boxes are
 * skipped during rendering.
 * o Played around with 3D transformations.  Still doesn't work.
 * 
 * 13    2/04/05 7:37p Eaddy
 * o Small changes to the base transformation
 * 
 * 12    2/04/05 5:12p Edp2002
 * added some functions for animation ... HOORAH
 * 
 * 11    2/04/05 5:22p Jrw2005
 * orientation right, but some normals are flipped...
 * 
 * 10    2/04/05 4:47p Jrw2005
 * got it oriened!
 * 
 * 9     2/04/05 3:36p Edp2002
 * now returns Frame for xfile ... robustability
 * 
 * 8     2/04/05 3:08p Edp2002
 * Added ability for multiple addXFile calls
 * 
 * 7     2/04/05 1:10p Eaddy
 * o Added extra checks
 * 
 * 6     2/02/05 8:09p Eaddy
 * o Fixed a problem with the textures. However, it still doesn't look
 * right and the lab model appears to be reversed.
 * 
 * 5     2/02/05 8:01p Eaddy
 * o Excludes bounding boxes (named "Geom")
 * o Fixed bug where material color wasn't used when using only ambient
 * light.  Needed to intialize the ambient color to be diffuse color.
 * o Fixed bug where textures weren't being loaded (because the Gaia
 * exporter uses full paths).
 * 
 * 4     2/02/05 5:06p Eaddy
 * o Removed commented code
 * 
 * 3     2/02/05 5:06p Eaddy
 * o Removed effects code
 */

using Phx.Aop.Attributes;

using System;
using System.IO;
using System.Diagnostics;
using System.Xml.Serialization;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

using Columbia.Utilities;

namespace Goblin.Engine.Scene
{
	/// <summary>
	/// Summary description for SceneGraph.
	/// </summary>
	[Feature("SceneGraph")]
	[Requirement("Rendering.Scene graph (#735)")]
	public class SceneGraph : IDisposable
	{
		public const int SKIP_PASS = -1;
		public const int GEOMETRY_PASS = 0;
		public const int CAMERA_PASS = 1;

		[Requirement("Debugging.Application visualization (#620)")]
		[Requirement("App Development.Collision detection (#1150)")]
		public const int BOUNDING_VOLUME_PASS = 2;

		[Requirement("Configuration.Device configuration files (#135)")]
		[Requirement("Rendering.Dynamic scene geometry (#740)")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		[Requirement("Configuration.Import - DirectX (#720)")]
		private XFileManager xfileMgr = new XFileManager();
		
		private Node rootNode = new Node("root");

		[Requirement("Debugging.Application visualization (#620)")]
		[Requirement("App Development.Collision detection (#1150)")]
		public bool showBoundingVolumes = false;
		
		// For some reason we get an exception when we try to
		// read device.RenderState.FillMode which is why we
		// use the fillMode variable
		[Requirement("Debugging.Application visualization (#620)")]
		[Requirement("Operational.Performance tuning (#1325)")]
		public FillMode fillMode = FillMode.Solid;
		
		[Requirement("Debugging.Application visualization (#620)")]
		[Requirement("App Development.Collision detection (#1150)")]
		public FillMode fillModeBoundingVolume = FillMode.WireFrame;

		public SceneGraph()
		{
			//[Requirement("Configuration.Device configuration files (#135)")]
			//[Requirement("Rendering.Dynamic scene geometry (#740)")]
			//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
			//[Requirement("Configuration.Import - DirectX (#720)")]
			xfileMgr.RegisterDefaultTemplates();
		}

		[Requirement("Nonfunctional.Clean shutdown (#1405)")]
		public void Dispose()
		{
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (xfileMgr != null)
				//[Requirement("Nonfunctional.Clean shutdown (#1405)")]
				//[Requirement("Configuration.Device configuration files (#135)")]
				//[Requirement("Rendering.Dynamic scene geometry (#740)")]
				//[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
				//[Requirement("Configuration.Import - DirectX (#720)")]
				xfileMgr.Dispose();

			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (rootNode != null)
				//[Requirement("Configuration.Import - DirectX (#720)")]
				rootNode.Dispose();
		}

		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("App Development.Object model (#1110)")]
		public Node RootNode
		{
			get { return rootNode; }
		}

		[Requirement("Configuration.Device configuration files (#135)")]
		[Requirement("Rendering.Dynamic scene geometry (#740)")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		[Requirement("Configuration.Import - DirectX (#720)")]
		public XFileManager XFileManager
		{
			get { return xfileMgr; }
		}

		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("Rendering.Dynamic scene geometry (#740)")]
		public Node AddNode(Node node)
		{
			return rootNode.AppendChild(node);
		}

		[Requirement("Rendering.Scene graph (#735)")]
		[Requirement("Rendering.Graphics API integration - Direct3D (#700)")]
		[Requirement("Rendering.Dynamic scene geometry (#740)")]
		[Requirement("Configuration.Import - DirectX (#720)")]
		public Node AddMesh(	Device device,
								string name,
								string directory,
								Mesh mesh, 
								GraphicsStream adjacency, 
								ExtendedMaterial[] materials)
		{
			Node node = new Node(name);
			node.SetMesh(device, directory, mesh, adjacency, materials, "");
			return rootNode.AppendChild(node);
		}

		public void CombineTransformations(Device device, Matrix worldMatrix)
		{
			rootNode.CombineTransformations(rootNode, device, worldMatrix);
		}

		public void FrameMove(Device device, float elapsedTime)
		{
			rootNode.FrameMove(rootNode, device, elapsedTime);
		}

		public void Render(Device device, Microsoft.DirectX.Vector3 origin, string filter)
		{
			rootNode.Render(device, filter, SceneGraph.GEOMETRY_PASS);
			rootNode.Render(device, filter, SceneGraph.CAMERA_PASS);

			//[Requirement("Debugging.Application visualization (#620)")]
			//[Requirement("App Development.Collision detection (#1150)")]
			if (showBoundingVolumes)
			{
				Material mat = new Material();
				mat.Ambient = System.Drawing.Color.Blue;

				// Bounding volumes are defined using the transformed vertices
				// so we don't need to adjust the world transform
				device.Transform.World = Matrix.Identity;

				device.Material = mat;
				device.SetTexture(0, null);
			
				if (fillMode != fillModeBoundingVolume)
					device.RenderState.FillMode = fillModeBoundingVolume;

				rootNode.Render(device, filter, SceneGraph.BOUNDING_VOLUME_PASS);

				if (fillMode != fillModeBoundingVolume)
					device.RenderState.FillMode = fillMode;
			}
		}
	}
}
