///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2005 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Engine/Scene/Transformers/CollisionSticker.cs 5     1/12/07 2:23p Eaddy $
//
//    File name:	CollisionSticker.cs
//   Created by:	Marc Eaddy
//   Created on:	04/18/2005
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Engine/Scene/Transformers/CollisionSticker.cs $
 * 
 * 5     1/12/07 2:23p Eaddy
 * o After annotating all statements with their corresponding requirements
 * 
 * 4     9/29/06 6:18p Eaddy
 * o Annotated program elements with the concern they realize
 * 
 * 3     5/28/05 1:21p Eaddy
 * Changed copyright
 * 
 * 2     5/17/05 3:20a Eaddy
 * o Fixed compile error
 * 
 * 1     4/22/05 4:59p Eaddy
 * o Broke out Transformer and CollisionListener classes into separate
 * files
 */

using Phx.Aop.Attributes;

using System;

using Microsoft.DirectX.Direct3D;	// IntersectionInformation

namespace Goblin.Engine.Scene
{
	/// <summary>
	/// Handles object collisions by having the object "stick" to the
	/// object that it collided with.
	/// </summary>
	[Feature("SceneGraph.CollisionDetection")]
	[Requirement("App Development.Collision detection (#1150)")]
	public class CollisionSticker : ICollisionListener
	{
		public void OnBeforeCollided(	Node node, 
										Node root,
										Node nodeHit,
										Xfrm old, 
										IntersectInformation intersect,
										Xfrm desired)
		{
			// Do nothing
		}

		public void OnCollided(	Node node, 
								Node root,
								Node nodeHit,
								Xfrm old, 
								Xfrm collided,
								IntersectInformation intersect,
								ref Xfrm desired)
		{
			desired = collided; // Move next to the object we collided with
		}
	}
}
