///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2005 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Engine/Scene/Transformers/CombinerTransformer.cs 3     1/12/07 2:23p Eaddy $
//
//    File name:	CombinerTransformer.cs
//   Created by:	Marc Eaddy
//   Created on:	06/02/2005
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Engine/Scene/Transformers/CombinerTransformer.cs $
 * 
 * 3     1/12/07 2:23p Eaddy
 * o After annotating all statements with their corresponding requirements
 * 
 * 2     9/29/06 6:18p Eaddy
 * o Annotated program elements with the concern they realize
 * 
 * 1     6/02/05 9:22p Eaddy
 * o Initial checkin
 */

using Phx.Aop.Attributes;

using System;

using System.Collections;

using Microsoft.DirectX;

namespace Goblin.Engine.Scene
{
	[Feature("SceneGraph.Movement")]
	[Requirement("Rendering.Scene graph (#735)")]
	public class CombinerTransformer : Transformer
	{
		ArrayList transformers = null;

		public Xfrm baseXfrm = new Xfrm();

		public CombinerTransformer()
		{ }

		public CombinerTransformer(Transformer next)
		{ 
			AddTransformer(next);
		}

		public void AddTransformer(Transformer next)
		{
			if (transformers == null) // Lazy initialization
				transformers = new ArrayList();
			transformers.Add(next);
		}

		public override bool GetDesiredPosition(Xfrm cur, float elapsed, ref Xfrm desired)
		{
			//[Requirement("Debugging.Exception/error detection (#625)")]
			if (transformers == null)
			{
				//[Requirement("Debugging.Exception/error handling (#630)")]
				return false;
			}

			desired = baseXfrm.Copy();

			for(int i = 0; i < transformers.Count; ++i)
			{
				Transformer transformer = (Transformer) transformers[i];
				desired.position *= transformer.current.position;
				//desired.rotation *= transformer.current.rotation;
			}

			return desired.position != cur.position;
		}
	}
}
