///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2005 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Engine/Scene/Transformers/InverterTransformer.cs 6     1/12/07 2:23p Eaddy $
//
//    File name:	InverterTransformer.cs
//   Created by:	Marc Eaddy
//   Created on:	04/18/2005
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Engine/Scene/Transformers/InverterTransformer.cs $
 * 
 * 6     1/12/07 2:23p Eaddy
 * o After annotating all statements with their corresponding requirements
 * 
 * 5     9/29/06 6:18p Eaddy
 * o Annotated program elements with the concern they realize
 * 
 * 4     5/28/05 1:21p Eaddy
 * Changed copyright
 * 
 * 3     5/25/05 6:28p Eaddy
 * o Removed unused class
 * 
 * 2     4/25/05 4:42p Eaddy
 * o Transformer no longer stores the Node. This eliminates an unnecessary
 * circular dependency
 * between Node and Transformer, allows Transformers to be reused, and
 * simplifies the design.
 * 
 * 1     4/22/05 4:59p Eaddy
 * o Broke out Transformer and CollisionListener classes into separate
 * files
 */

using Phx.Aop.Attributes;

using System;

using Microsoft.DirectX;			// Matrix
using Microsoft.DirectX.Direct3D;	// IntersectionInformation

namespace Goblin.Engine.Scene
{
	/// <summary>
	/// </summary>
	[Feature("SceneGraph.Movement")]
	[Requirement("Rendering.Scene graph (#735)")]
	public class InverterTransformer : Transformer
	{
		Transformer original;

		public InverterTransformer(Transformer original)
		{ 
			this.original = original;
		}

		public override bool GetDesiredPosition(Xfrm cur, float elapsed, ref Xfrm desired)
		{
			bool moved = original.GetDesiredPosition(cur, elapsed, ref desired);
			//[Feature("Opt")]
			//[Requirement("Operational.Minimum frame rate of 15 fps (#1305)")]
			//[Requirement("Operational.Maximum user input latency of 1 second (#1310)")]
			//[Requirement("Operational.Target frame rate of 60 fps (#1300)")]
			if (moved)
			{
				//[Feature("Opt")]
				//[Feature("SceneGraph.Movement")]
				//[Requirement("Rendering.Scene graph (#735)")]
				desired.position.Invert();
			}
			
			//[Requirement("Operational.Minimum frame rate of 15 fps (#1305)")]
			//[Requirement("Operational.Maximum user input latency of 1 second (#1310)")]
			//[Requirement("Operational.Target frame rate of 60 fps (#1300)")]
			return moved;
		}
	}
}
